// AlaMag -- Copyright(C) 1999-2009 Pieter B. Visscher, see main.cpp for notices
// This is Contour.cpp
//#include <iostream>
#include "Lowest.h"
#include "Systm.h"
#include "Contours.h"
#include "cell.h"
#include <string>
//using namespace std;

  ContourHolder::ContourHolder() // constructor
    {
		string junk;
		real EInc;
		if(My->Heun) cout<<"Turning Heun off, not compatible with landscape"<<endl;
		My->Heun = 0;
		if(My->DampingFinite) cout<<"Overriding finite damping for landscape"<<endl;
		My->DampingFinite = 0; // and gamma is irrelevant
		My->paramFile>>junk>>NEnergies;
		My->CheckScript(junk,"Landscape");
		EContour = new real[NEnergies];
		My->paramFile>>EContour[0]>>EInc>>MTol;
		cout<<"Setting up contours, #="<<NEnergies<<", increment="<<EInc<<", 1st energy="<<EContour[0]<<endl;

		for (short i=1; i<NEnergies; i++)
		{EContour[i] = EContour[i-1]+EInc; cout<<"EContour="<<EContour[i];}
		cout<<endl;
    }

  /* DELETE    void ContourHolder::ReadContours()
{
	string junk;
	OLD My->paramFile>>junk>>ECont1; // later read many contours, perhaps in function
	assert(junk[2]='n'); // shd be "Landscape"
	// 
}
*/

// There is a similar function for dm/dh in class Constrain -- could combine?
void   ContourHolder :: CalcMomentsDerivs() // calc. MVal, ddEdh
{ // assumes H_lin, H_quad known (sum=H_av)
   // loop over modes: set ddEdh, MVal = 0
	// where is rationale for this? 6 or 7/2011 in Landscape (S) #d pages? 
	short iMode;
	MVector H0; // will be field with HVal0???? instead of HVal
	MVector H0Perp; // will be part perp to M, i.e. MxHxM/Ms^2
	for (iMode=1; iMode<=My->NModes;iMode++) 
	  {My->Modes[iMode]->ddEdh=0.0; My->Modes[iMode]->MVal=0.0;}
   DeltaE0=0.0;  // this will be value with field HVal (before changes in ContourCB)
   for (CellIDType i=0;i<LLGcell::NextSmCellID;i++) 
   { // this is only over SMALLEST cells
	   LLGcell*c1 = My->CellFromID[i];
       My->CalcShapeFCell(c1);
	   H0=c1->H_av(); // adds H_lin and H_quad; H0 is temporary name here
	   MVector MxHxM = H0*c1->rect->Ms*c1->rect->Ms - c1->M*(c1->M*H0); //same as in CalcDelM,
		   // but BAC-CAB rule, quicker
	   // debug: check this really is same as in CalcDelM!! Should go there shortly.
	   // THIS NEEDS FIXING:
	   //for (iMode=1; iMode<=My->NModes;iMode++) // correct H0 with HVal0 instead of HVal
	   //   My->Modes[iMode]->CorrectH(H0,c1->volume()); // needs fixing
	   MVector H0Perp = H0 - c1->M*(c1->M*H0)/(c1->rect->Ms*c1->rect->Ms); // MxH0xM/Ms^2
	   // assert(abs(H0Perp*c1->M) < 0.00001); // should be perp

       DeltaE0-= H0Perp*(MxHxM)*c1->rect->gadtM*c1->volume();
	   // use cell :: H_av & Mode :: ddEdh
	   for (iMode=1; iMode<=My->NModes;iMode++) 
	   {
		   MVector F = My->Modes[iMode]->ShapeF;
		   MVector MxFxM = F*c1->rect->Ms*c1->rect->Ms - c1->M*(F*c1->M); //BAC_CAB
	       My->Modes[iMode]->ddEdh-= (H0Perp*MxFxM)*c1->rect->gadtM;
	       My->Modes[iMode]->MVal+= F*c1->M; // actual moment
	   }
   } // end for i
   // DeltaE0*=My->dt;
} // end function CalcMomentsDerivs
   
void ContourHolder::ContoursCB()
{  // On entry, assumes M known, CalcAllFromM calc'd H from Modes->HVal
   cout<<"FIX ContoursCB!!"<<endl; MYEXIT(23);
/*
   CalcMomentsDerivs();
   My->CalcEnergy(); // uses HVal, not HVal0??; correct for modes 1&2 below
   real grad2 = 0.0;
   real H2=0.0; // magnitude of h vector
   for (short i=1; i<3; i++) // assume 2D contour plot
   {   Mode* Mo=My->Modes[i]; // short notation
	   grad2+= Mo->ddEdh*Mo->ddEdh;
	   H2+=Mo->HVal*Mo->HVal;
	   // FIX THIS: 4/2012 think HVal0 can always be 0, effectively
	//   My->Energy+=Mo->MVal*(Mo->HVal-Mo->HVal0); // energy had -MVal*HVal, correct to HVal0
   }
   assert(grad2!=0.0);
   //real ETol = MTol*sqrt(H2); // tolerance for contour; can be zero, just won't stop then 
   real EDiff = EContour[0] - My->IntEnergy; // or total energy???
   if(abs(EDiff)<0)// for debugging! ) // stop iteration, write point on contour, move along contour
   {
	   // cout<<"New point,"<<My->Modes...
	 // insert point in the contour...
     real b = 0.01*My->root->rect->Ms/sqrt(grad2); // normalize delta-H
     My->Modes[1]-> HVal-=My->Modes[2]->ddEdh*b;  
     My->Modes[2]-> HVal+=My->Modes[1]->ddEdh*b;  
   }

   real a = (EDiff - DeltaE0)/grad2; // 0 will eventually be a variable
   cout<<"In ContoursCB,"<<endl;
   // a = 0; // for debugging
   for (short i=1; i<3; i++) 
   {
	   My->Modes[i]-> HVal+=a*My->Modes[i]->ddEdh;
	   cout<<"mode "<<i<<", HVal="<<My->Modes[i]-> HVal<<endl;
   }
   //cin.get();
   My->CalcAllFromM(1); // because evolve assumes fields known
   My->evolve();
   //See how close you are to EContour[], if close, write point, move sideways, 
   // Find some way to stop when we finish contour .... then go to next contour
*/
} // end function ContoursCB
