#ifndef NORMODES_H
#define NORMODES_H
//#include "Systm.h" // contains other .h's
#include <list> // is STL list

// #include "types.h"
// #include "utility.h"
#ifdef _GROUPS
   class Nesting;
   class NestHolder;
#endif

class ModeCx // mode with real and imaginary parts
{  public:
   // Real and imaginary part of the perturbation 
   Config ModeRe, ModeIm;
   //period and critical current 
   real Period, JCrit;
   //Symmetry and group 
#ifdef _GROUPS
   std::list<Nesting>::iterator ModeNest;
   short ModeGroup;
#endif
   void WriteHeader(ostream&);
  friend ostream& operator<< (ostream&, const ModeCx&); 
  friend istream & operator>> (istream &, ModeCx &); 
};

class NorModes // the analog of Orbits.cpp's OrbitHolder; there is only one
{  public:
   // variables read from paramFIle
   //real perturbation;// scale of perturbation
   //Mode* SeedMode; // Seedmode - mode from which the current NorMode is being made
   Mode* DriverMode; // driver mode= mode being constrained usually spin torque (was short,now ptr)
   //real Max_critical_current; // if adjusted torque is above this limit, no more complex NM is needed 
   //std::list<Nesting>::iterator NormNest;//symmetry 
   //short nGroup;

   ModeCx* CurModeCx;// current Curmode
   std::list<ModeCx> ModeListCx; // list of normal modes 
   real counter;// convergence counter
   ifstream ModesInF;
   ofstream ModesOutF;
 
   //information when time=0
   Config Meq;// Magnetization  at energy minimum 
   Config Po; // Perturbation at t=0
   real Pmag;// Po^2

   //Information at current time step 
   Config Mnow;// current magnetization as a config 
   Config Mtnow; //current dM/dt 
   Config Pt; //current perturbation
   Config dPt; // d current pertubation/dt 
   real PoPt, PodPt; //product of Po and dPt
  
 
   //Information at previous time step 
   Config Pt_prev; //previous perturbation, needed to find p exactly when PodPt=0
   real PodPt_prev; //previous product of dPt

   //Information from last cycle 
   Config Pt_prev_cycle; //perturbation from last cycle to check for convergence
   double t_prev;// previous time PodPt crossed zero
    
   // functions
   NorModes(); // constructor
   ~NorModes();

   // void ReadNM(ifstream& Fil);
  void StartNewModeCx(ifstream&); // read about & start a new complex mode 
  void StartNewCycle(); // start a new cycle in normal mode calculation 
  void QuarterEnd();// go quarter of a cycle to store imaginery part after convergence of real part of theh normal mode
  void UpdateNormMode(); // update PoPt and PodPt at every time step. gets called in CheckForCycleEnd
  void setNormalModeFromScript(ifstream& Fil); // normal mode calculation information from the paramfile,
  void CheckForCycleEnd(); // Check for convergence after end of a cycle
  void ProjectOutAndEnforceSymmetry(); //Enforce symmetry 
   
};
#endif // NORMODES_H