#ifndef OUTPUTS_H
#define OUTPUTS_H

// Systm includes
//#include "Lowest.h"
class Rectang;

#define Max_N  10 // maximum number of quantities to average

class Average{
  // averages a collection of vector variables that are defined at the same type  // of cell or face, so number of samples NSamp is the same for each.

  public:

  //********data members***************
  short N; //number of (vector) variables to average products of
  real *Avg; //array of averages
  static real *val; //individual values to be averaged
  short NSamp; //number of vals sampled (e.g., cells * times)

  //******** constructor ****************
  Average(short N0) {
    N = N0;
    Avg = new real[N];
   }

  //******** member functions*************
  void init(); //double loop over i&j computes composite index(ij)
  void increment(); //accumulates val into Avg and Avg2
  void normalize(); //divide out number of samples
  void WriteandInit(); //write the average to a file and reinitialize to zero
 };

class Integrals
{
public:
	const short NumInt;
	float *ValInt;
	//float* FFF;
		//member functions
	void InitializeInt();
	Integrals(short);
	~Integrals();
	Integrals operator=(const Integrals&); // dummy to suppress warning 4512;
	  // we never actually use this
};
//end class Integrals

/*
class Magnetoresistance
{
public:
	Magnetoresistance(Rectang*,Rectang*);
	real MR; // calculates sum of cos(angle between M's) over facing pairs of cells
	  // if wanted to be fancy, add R0 and add reciprocals (conductances)
    Rectang *Rect0, *Rect1; // layers before and after junction involved in MR
};
*/

#endif // OUTPUTS_H
