//this is Quaternion.C file

#include "Lowest.h"
#include "Quaternion.h"
#define ANGTOL .01  //commented by DMA, moved to Quaternion.h
//real rand1(); // defined in Random.cpp

//
// constructor
//

Quaternion::Quaternion (real x0, real x1, real x2, real x3){
  q0= x0; q1= x1; q2= x2; q3= x3;
}

//
// initializes a Quaternion from a MVector
//

// inline removed by mourad


Quaternion::Quaternion (MVector v, real v0){
  q0= v0;
  // parameters are references to q1, q2 and q3
  v.CopyTo(q1, q2, q3);
}

//
// destructor
//

void Quaternion::qRot(MVector axis)
{
  //this rotates about axis by angle=abs(axis)
  // Logically it should be a constructor.
  // But there is already a constructor taking a vector argument.
  real angle=axis.Magnitude();
  if(angle<ANGTOL) //use small angle form
   { 
     q0 = 1.0; 
     MVector temp = (axis*.5);
     temp.CopyTo(q1,q2,q3);
    }
  else //use exact formula
   {
    real ang2 = .5*angle;
    MVector temp = axis*sin(ang2)/angle;
    q0 = cos(ang2);
    temp.CopyTo(q1,q2,q3); //sets q to temp
   }
}


Quaternion::~Quaternion(){;}


//
// overloading the operator << to print Quaternions.
//

ostream& operator<<(ostream &fout, Quaternion q){
  fout<<q.q0 << "  " << q.q1 << "  " << q.q2 << "  " << q.q3;
  return fout;
}

istream& operator>> (istream& fin, Quaternion& q){
  char c1,c2;
  fin>> c1 >> q.q0 >> q.q1 >> q.q2 >> q.q3 >> c2;
  assert(c1 == '(');
  assert(c2 == ')');
  return fin;
}


/* delete
void
Quaternion::set_to_random_normalized()
{
  q0 = rand1()-0.5;
  q1 = rand1()-0.5;
  q2 = rand1()-0.5;
  q3 = rand1()-0.5;

//    q0 = sqrt(2.)/2.;
//    q1 = 0.;
//    q2 = sqrt(2.)/2.;
//    q3 = 0.;

  
//    q0 = sqrt(2.)/2.;
//    q1 = 0.;
//    q2 = 0.;
//    q3 = sqrt(2.)/2.;

//      q0 = 1.;
//      q1 = 0.;
//      q2 = 0.;
//      q3 = 0.;

  (*this) *= 1/sqrt(this->norm());
  assert( this->norm() < 1.01 &&  this->norm() > 0.99); 

  //cout<<" rotation : ";this->iv_print()<<endl;
}
*/

ostream& Quaternion::iv_print(ostream& fout) const{
  //  Quaternion q = this->GetAngleAndAxis_rad();
  //  fout<<q.q1<<"  "<<q.q2<<"  "<<q.q3<<"  "<<q.q0;
  fout<<"  "<<q1<<"  "<<q2<<"  "<<q3<<"  "<<q0<<" ";
  return fout;
}
