#include "SeaPlug.h"
#include "Systm.h"
#include "cell.h"
extern Systm* My;

/* Centers & halves now set in PutOnTree, don't need this:
  (besides, it seems not to work? Gives all zeroes? At least in SubCellContaining.)

void fixCentersHalvesRecursively(cell* cel) {
    if (cel->child0) {
        fixCentersHalvesRecursively(cel->child0);
        fixCentersHalvesRecursively(cel->child1);

        // find children's bounding box, may be an easier way of doing this
        MVector LL,UR;
        for (int i=0; i<VDIMENSION;i++) {
            LL[i] = min(cel->child0->center[i]-cel->child0->half[i],
                    cel->child1->center[i]-cel->child1->half[i]);
            UR[i] = max(cel->child0->center[i]+cel->child0->half[i],
                    cel->child1->center[i]+cel->child1->half[i]);
        }
        cel->center = (UR+LL)*0.5;
        cel->half = (UR-LL)*0.5;
        cel->radius2 = cel->half.Square();

    } // else LLGcells already good
}
*/

void initRectPartners(MVector& half) {
    My->root->rect->LLGSize = half; // so LLGSize is HALF size
    My->root->rect->RectInfoPtr= new CellInfo(My->root->rect->LLGSize);

    // set AnisPower here, if needed?
    
    // set rect->alpha, Ms, etc if needed
    
    // face creation, init M not needed.
     /*for (CellIDType i=0;i<LLGcell::NextSmCellID;i++){
        My->CellFromID[i]->CreateFaces();
        // no init M
     }*/


    My->MyFMM->CubeKer = new std::map<int3,Kernel>;
    My->MyFMM->ReadKernels("Kernels.dat",My->MyFMM->CubeKer);
        for(int iRect=0;iRect<My->NRects;iRect++)
	{  Rectang* rec=My->RectFromID[iRect];
       if (rec->LLGSize.Is111()) rec->RectKer=My->MyFMM->CubeKer; // can use same cubic kernels
	   else 
	   {  rec->RectKer = new std::map<int3, Kernel>; // make new kernel list
	      EXIT1("Whoops! Non-cubes not supported yet");
	   }
	    // later might check if other rect has same LLGSize???
	}


    My->CreatePartners();
} // end fn. InitRectPartners

void PutOnTree(CellIDType N, real3 *cen, real3 cellsize,
               real FMM_OPENING_ANGLE, unsigned short FMM_USED_MPOLE_ORDER)
{   cout<<"Entering PutOnTree, about to create FMM"<<endl;
    MVector cellhalf; cellhalf.SetToArray(cellsize); cellhalf*=0.5;
    // creates FMM object for cells, must be done before cell creation.

    My->MyFMM = new FMM();
	My->MyFMM->MaxOrder = FMM_USED_MPOLE_ORDER; // may be changed by DBG_
    My->MyFMM->UsedOrder = FMM_USED_MPOLE_ORDER;

#ifdef DBG_ // debug Green's function
	// copy code from where fmm is read in ReadScript()
	// sets up class DebugGreen, sets order, source M direction
	// changes MaxOrder if necessary
	My->FMM->MaxOrder = 5; // set this to desired max order for debug check
	fix this
#endif // DBG_

    My->MyFMM->MaxAngle2 = FMM_OPENING_ANGLE;
	My->MyFMM->setup(); // set up lots of arrays, depend on MaxOrder

    // cout<<"about to create root cell, N="<<N<<endl;
    // setup rectangle and root cell
    if(N>1) My->root = new cell();
    else My->root = new LLGcell();

    cout<<"about to create Rectang"<<endl;
    My->root->rect = new Rectang(My->root);

    LLGcell::NextSmCellID = N; // this is what we call the number of cells
    My->CellFromID = new LLGcell*[LLGcell::NextSmCellID];
    if(N==1) {
        My->CellFromID[0] = static_cast<LLGcell*>(My->root);
        My->CellFromID[0]->SmCellID = 0;
        My->root->center.SetToArray(cen[0]);
        My->root->half = cellhalf;
        My->root->radius2 = My->root->half.Square();
        initRectPartners(My->root->half);
        return;
    } // end if(N++1)
        #define MaxBins 20 // 20 should be plenty
#ifdef DEBUG1
        MVector WatchVector=MVector(0,0,0); // use below to define WatchedLLGCell
        MVector WatchPartV=MVector(0,0,0); // define watched partner
         // used to determine pointer WatPart during PutOnTree.  Note that this
         // can be undone at end of PutOnTree, can set WatPart=NULL, meaning use all.
        CellIDType NW = 1 ; // 72594; // node to watch; -1 disables
        unsigned short LW = 0; // level to start watching
#endif  //  DEBUG1
        CellIDType i,DevPrev,DevHalf=99999999; //  flag uninitialized
        unsigned short j,Level;
	cell** NodePointers = new cell*[N]; // basic scratch array; 
	// NodePointers[i]=node at current Level containing small cell i
	real3* MinPos = new real3[N]; // leftmost point (in each of 3 directions)
	real3* MaxOrWid = new real3[N]; // rightmost point, later bin width
        unsigned char* NumBins = new unsigned char[N]; // number of bins
	unsigned char* LDir = new unsigned char[N]; // long direction: 0,1, or 2
	real* CutPoint = new real[N]; 
	  // Dividing plane between children along long direction
	int* First = new int[N]; //First[i]=first cell under node NodePointers[i]
	int* NodeSize = new int[N]; 
          // NodeSize[First[i]] = number of cells under node NodePointers[i]
    int (*NumInBin)[MaxBins] = new int[N][MaxBins];
    unsigned int * child0first = new unsigned int[N];
    unsigned int * child1first = new unsigned int[N];

	int NI; // scratch; node index
        cell* NodePtr;
	unsigned char LD; // scratch; long direction
	unsigned char BinNumber;
	int Cumul,CumulNew;
	bool AllCellsSmall=false;

        //  cout<<"About to loop cells to initialize"<<endl;
	for (i=0;i<N;i++) {
        My->CellFromID[i]=NULL;
        NodeSize[i]=0;
		First[i]=0; // 0 is first cell under root
		NodePointers[i]=My->root; // each cell is under root
	}
    NodeSize[0]=N;
	for (Level=0; !AllCellsSmall; Level++) // loop levels; 0 is top
	{  // NodePointers is now correct for level Level; 
	   // determine it for level Level+1
		AllCellsSmall = true;

// ******** LOOP(0) CELLS TO INITIALIZE *********************
		// zero out NumInBin
		for (i=0;i<N;i++) for(j=0;j<MaxBins;j++) NumInBin[i][j]=0;

// *********LOOP(1) NODES FOR BOUNDING BOX *******************
                cout<<"Loop nodes on level "<<Level<<" to get bounding boxes."<<endl;
		for (i=0;i<N;i++)
		{  // get left and right of each cell i at Level
			// note that MaxOrWid[i] refers not to user cell i but to 
			// tree node NodePointers[i] (which contains i)
			NodePtr = NodePointers[i]; 
			NI = First[i]; // node index; where to store info 
			  // about node in arrays
			assert (NodePtr==NodePointers[NI]);
			if (NI==i) {
				// initialize these for this node
				for (j=0;j<3;j++) { MaxOrWid[NI][j]= cen[i][j]+cellhalf[j];
				   MinPos[NI][j]= cen[i][j]-cellhalf[j];}
			} else {
				// already initialized, make sure each dimension is max/min.
				for (j=0;j<3;j++) 
				{
					if (cen[i][j]+cellhalf[j]>MaxOrWid[NI][j]) 
						MaxOrWid[NI][j]=cen[i][j]+cellhalf[j];
					if (cen[i][j]-cellhalf[j]<MinPos[NI][j]) 
						MinPos[NI][j]=cen[i][j]-cellhalf[j];
				}
			}
		} // end for i
		// now for each node NI at this level, 
		// MaxOrWid[NI][j] is the rightmost cell center under this node
    
// ************  LOOP(2) NODES FOR LONG DIRECTION AND BINS *****************
                cout<<"  Loop nodes again to find long direction and bins."<<endl;
                for (i=0;i<N;i++)
			if(First[i]==i) if(NodeSize[i]>1)// loop nodes, not cells 
			{ // find long direction
				real MaxLen = MaxOrWid[i][0]-MinPos[i][0]; LDir[i]=0; //initialize
				for (unsigned char j=1;j<3;j++) 
				{   real Len = MaxOrWid[i][j]-MinPos[i][j];
					if (Len>MaxLen) {MaxLen = Len; LDir[i]=j;}
				} // end for j
                real NB = MaxLen/cellsize[LDir[i]]; // number of cell widths
                if (NB>MaxBins) NumBins[i]=MaxBins; else NumBins[i]=(unsigned char)floor(NB+0.001);

                if(NumBins[i]<2) 
                {  cout<<"Error, NumBins="<<(short)NumBins[i]<<" for node "<<i<<
                     " of size "<<NodeSize[i]<<
                     ", NB="<<NB<<" = "<<MaxLen<<"/"<<cellsize[LDir[i]]<<endl;
                   MYEXIT(11);
                }
                
                NodePtr = NodePointers[i]; // insert cell size too
                NodePtr->center=0.5*MVector(MinPos[i][0]+MaxOrWid[i][0],
                  MinPos[i][1]+MaxOrWid[i][1],MinPos[i][2]+MaxOrWid[i][2]);
                NodePtr->half=0.5*MVector(MaxOrWid[i][0]-MinPos[i][0],
                  MaxOrWid[i][1]-MinPos[i][1],MaxOrWid[i][2]-MinPos[i][2]);
                NodePtr->radius2=NodePtr->half.Square();
#ifdef DEBUG1
                if(NodePtr->parent) // sanity check: 
                  if (!NodePtr->parent->Contains(NodePtr->center) )
                   cout<<"Error, cell center "<<NodePtr->center<<
                     " not in parent "<<*NodePtr->parent<<endl;

                MVector Diff=WatchVector-NodePtr->center;
                if (Diff.Square()<0.1) 
                {  My->WatchedCell=NodePtr;
                   cout<<"Defining WatchedCell = "<<i<<" = "<<NodePtr<<
                      " from WatchVector "<<WatchVector<<endl; 
                }// but note that smallest(LLG) cells don't get here, set WatchedLLGCell below 

                Diff=WatchPartV-NodePtr->center;
                if (Diff.Square()<0.1) 
                {  My->WatPart=NodePtr;
                   cout<<"Defining Watched Partner = "<<i<<" = "<<NodePtr<<
                      " from WatchPartV "<<WatchPartV<<endl; 
                } 

                if(i==NW) if(Level>=LW)
                {  cout<<"Node "<<i<<", NodeSize="<<NodeSize[i]<<
                     ", Found long dir LD="<<(short)LDir[i]<<", Maxlen="<<MaxLen<<", NB="<<NB<<
                     ", NumBins="<<(short)NumBins[i]<<endl;
                }
#endif  //  DEBUG1
                MaxOrWid[i][0]=MaxLen/NumBins[i]; // now bin width, use only [0]
		    } // end for-i-if-if (node loop)

// ********* LOOP CELLS (3) FOR HISTOGRAM ********************
                cout<<"  Loop cells to histogram positions in long direction"<<endl;
		for (i=0;i<N;i++) 
		{
            NI = First[i];  
            if(NodeSize[NI]<2) continue; // don't bother binning if 1 LLG cell
            LD = LDir[NI]; assert(LD<3); // sanity check
            //cout<<"    cen="<<cen[i][LD]<<", MinPos="<<MinPos[NI][LD]<<endl;
	    BinNumber =  (unsigned char)floor((cen[i][LD]-MinPos[NI][LD])/MaxOrWid[NI][0]);
            if (BinNumber == NumBins[NI]) BinNumber--; // exactly at the right
	    NumInBin[NI][BinNumber]++;

#ifdef DEBUG1
            if( (NI==NW) && (Level>=LW)) // debug print
               cout<<"In node "<<NI<<", Cell #"<<i<<",LD="<<(short)LD<<
                " @ "<<cen[i][0]<<","<<cen[i][1]<<","<<cen[i][2]<<
                ", bin width="<<MaxOrWid[NI][0]<<", in bin "<<(short)BinNumber<<endl;
#endif  //  
             
		} // end for i

// ********** LOOP (4)  CELLS TO MAKE CHILDREN ***********************
                cout<<"  Loop cells to sort into child nodes"<<endl;
		for (i=0;i<N;i++) if(NodeSize[i]!=1) // if size=1, no children, skip
		{ // note size=0 means haven't sorted yet -- need those
		    NI = First[i];
                    LD=LDir[NI]; // long direction
                    NodePtr = NodePointers[i]; // NOT [NI]! That may have changed!
#ifdef DEBUG1
                    if(NI==NW) if(Level>=LW) cout<<"At cell "<<i<<", in node "<<NI<<
                       ", of size (perhaps now child0) "<<NodeSize[NI]<<
                       ", pointer="<<NodePtr<<", child0="<<NodePtr->child0<<
                       ", child1="<<NodePtr->child1<<endl;
#endif  //  
		    if(NI==i) // first cell in its node, divide node
		    {   // Note that NodeSize[i] is messed up below, but should be still ok 
                        // because this is the FIRST cell of that node.

#ifdef DEBUG1
                       if(NI==NW) if(Level>=LW) cout<<"Is first in its node "<<NI<<
                        ", of size "<<NodeSize[i]<<", with NumBins="<<(short)NumBins[NI]<<endl;
#endif  //  
		        Cumul=0; // cumulative number in bins so far,  
			DevPrev=NodeSize[i]; //deviation of 2*Cumul from NodeSize
                          // ~ dev of Cumul from desired size, half NodeSize
                        //cout<<"First cell in node, at z="<<cen[i][2]<<", size="<<NodeSize[NI]<<
                        //     "Long dir="<<(short)LD<<endl;
		        for (BinNumber=0;BinNumber<NumBins[NI];BinNumber++) 
		        {   
                   CumulNew=Cumul+NumInBin[NI][BinNumber];
                   DevHalf=2*CumulNew-NodeSize[i]; // deviation from half
#ifdef DEBUG1
                   if(NI==NW) if (Level>=LW) // debug print 
                      {cout<<"Node "<<NI<<", size="<<NodeSize[NI]<<", LD="<<(short)LD<<
                      " First.cen= "<<cen[NI][LD]<<", Min="<<MinPos[NI][LD]<<
                       ", BinNumber="<<(short)BinNumber<<",CumulNew="<<CumulNew<<
                       ",DevHalf="<<DevHalf<<", NumBins="<<(short)NumBins[NI]<<endl;
                      } // end if NW (watched node) 
#endif  //  
	           if (DevHalf>=0) // past half
	           {  if (abs(DevHalf)<abs(DevPrev)) // closer now than before
                      {   BinNumber++; // put Cut Point to the right of this bin
                          Cumul=CumulNew;
                      }
			       // otherwise to left
			  goto BinLoopEnd; // jump out of BinNumber loop, 
                            // keeping this val of BinNumber & Cumul
               } // end if(Dev..)
                   DevPrev=DevHalf; // save for check
                   Cumul=CumulNew;
		        } // end bin loop
BinLoopEnd:
                // calculate cut point now for node
              CutPoint[NI]=MinPos[NI][LD]+BinNumber*MaxOrWid[NI][0];

                if(Cumul<1) // something is wrong
                {   cout<<"Problem with node "<<NI<<", Cumul="<<Cumul<<
                      ", NodeSize="<<NodeSize[NI]<<", DevHalf="<<DevHalf<<endl;
                    cout<<" Min="<<MinPos[NI][LD]<<", Wid="<<MaxOrWid[NI][0]<<
                       ", NumBins="<<(short)NumBins[NI];
                       cout<<", Cutting at "; 
                       if(abs(DevHalf)<abs(DevPrev)) cout<<"right"; else cout<<"left";
                       cout<<", cut@ "<<CutPoint[NI]<<endl;
                    for (CellIDType ii=0;ii<N;ii++) if (First[ii]==NI) // ii in node
                    {  BinNumber =  (unsigned char)floor((cen[i][LD]-MinPos[NI][LD])/MaxOrWid[NI][0]);
                         // this should be same as formula used above
                       cout<<"  cell # "<<ii<<" @ "<<cen[ii][LD]<<
                          ", in BinNumber "<<(short)BinNumber<<endl;
                    }
                    MYEXIT(22);
                 } // end if wrong
                       
                 // Create children now
		        if(Cumul==1) NodePtr->child0 = new LLGcell; 
		        else { NodePtr->child0 = new cell; AllCellsSmall=false; }
                        assert(NodePtr->child0);
		        // child0->parent = NodePtr; // do NOT set this yet, 
				                  // is flag that child0 is still empty
		        assert (NodeSize[i]>Cumul); // should be >=1 node left? 
				  
		        if((NodeSize[NI]-Cumul)==1) NodePtr->child1 = new LLGcell;
		        else { NodePtr->child1 = new cell; AllCellsSmall=false; }
                        assert(NodePtr->child1);
		        // child1->parent = NodePtr;
#ifdef DEBUG1
                   if(NI==NW) if (Level>=LW) // debug print
                      cout<<"Just created children of Node "<<NI<<", size="<<NodeSize[NI]<<
                         ", NodePtr="<<NodePtr<<", child0="<<NodePtr->child0<<
                         ", child1="<<NodePtr->child1<<endl;
#endif !DEBUG1  
		    } // end if first (NI=i)
		    // Now do things for every cell i:

		    if (cen[i][LD]<CutPoint[NI]) // is in child0
		    {
              assert(NodePtr);
              if(!(NodePtr->child0)) 
              {   cout<<"child0 null, of node "<<NI<<", trying to insert cell "<<i<<endl;
                  MYEXIT(45);
              } 
		        if(!NodePtr->child0->parent) 
		        {
                  child0first[NI]=i; // this is first cell in child0 
			         NodeSize[i]=0; // initialize
					   NodePtr->child0->parent = NodePointers[i];
                  if (typeid(*(NodePtr->child0))==typeid(LLGcell)) 
                  {
                     NodePtr->child0->center.SetToArray(cen[i]); // for now, 
						   // only set these for LLGcells. will fix for upper level cells later
					      NodePtr->child0->half = cellhalf;
                     My->CellFromID[i] = static_cast<LLGcell*>(NodePtr->child0);
                     My->CellFromID[i]->SmCellID=i;
						   NodePtr->child0->radius2 = NodePtr->child0->half.Square();
                  }
               } // end if first cell in child0
               NodePtr->child0->rect = NodePtr->rect;
				   First[i]=child0first[NI];
               NodePointers[i]=NodePtr->child0;
#ifdef DEBUG1
               if(NI==NW) if(Level>=LW) cout<<"Put cell "<<i<<", into child0 of node "<<NI<<
                   ", pointer="<<NodePtr<<", child0="<<NodePtr->child0<<endl;
#endif  //  
		    } // end if child0
		    else // is in child1
		    {
              assert(NodePtr);
              assert(NodePtr->child1);
		        if(!NodePtr->child1->parent) 
              {
			         child1first[NI]=i; // this is first cell in child1
                  NodeSize[i]=0; // re-initialize
                  NodePtr->child1->parent = NodePointers[i]; // still points to parent
                  if (typeid(*(NodePtr->child1))==typeid(LLGcell)) 
                  {  NodePtr->child1->center.SetToArray(cen[i]); // for now, only 
						   // set these for LLGcells. will fix for upper level cells later
					      NodePtr->child1->half = cellhalf;
                     My->CellFromID[i] = static_cast<LLGcell*>(NodePtr->child1);
                     My->CellFromID[i]->SmCellID=i;
						   NodePtr->child1->radius2 = NodePtr->child1->half.Square();
                  }
				  } // end if first cell in child1
              NodePtr->child1->rect = NodePtr->rect;
		        First[i]=child1first[NI];
	           NodePointers[i]=NodePtr->child1;		 
#ifdef DEBUG1
              if(NI==NW) if(Level>=LW) cout<<"Put cell "<<i<<", into child1 of node "<<NI<<
                   ", pointer="<<NodePtr<<", child1="<<NodePtr->child1<<endl;
#endif  //  
		    } // end else child1

#ifdef DEBUG1
                if(NI==NW) if(Level>=LW) cout<<"Done with cell "<<i<<endl;
#endif  //   
		    NodeSize[First[i]]++; // count cells; note this screws up NodeSize[NI] (parent)
                     //  and NodeSize[children] is correct only at end of i loop
		} // end for-i-if
	} // end for Level

    //cout<<"Fix centers.."<<endl;
    // gone: fixCentersHalvesRecursively(My->root);

#ifdef DEBUG1
cout<<"DEBUG1 defined"<<endl;
#else
cout<<"DEBUG1 not defined"<<endl;
#endif  //  

#ifdef DEBUG1
    // Check correctness of result: are all cells there?
    MVector VCenter,Diff;
    for (i=0;i<N;i++)
    {  VCenter=MVector(cen[i]); // where the input file thought it was
       LLGcell* NodePtr = My->root->SubCellContaining(VCenter);
       if (!NodePtr) {cout<<"Cannot find cell containing cell # "
         <<i<<" @ "<<VCenter<<endl; MYEXIT(11);}
       MVector Diff=NodePtr->center-VCenter; // discrepancy w/ where we put it
       if (Diff.Square()>1e-6) 
       { cout<<"Center copied incorrectly for cell #"<<i<<" @ "<<cen[i]<<
         ", came out as "<<NodePtr->center<<endl; MYEXIT(25);
       }
       Diff=WatchVector-NodePtr->center; // now define watched cell, if smallest
       if (Diff.Square()<0.1) // if larger, was defined above.
       {  if(My->WatchedLLGCell) cout<<"WatchedLLGCell already defined as "<<My->WatchedLLGCell<<
            " but still"<<endl; 
          cout<<"Define WatchedLLGCell = #"<<i<<" = "<<NodePtr<< 
            " from WatchVector "<<WatchVector<<endl; 
          My->WatchedLLGCell = NodePtr;
       } 

       Diff=WatchPartV-NodePtr->center; // similarly for watched partner
       if (Diff.Square()<0.1) 
       {  if(My->WatPart) cout<<"Watched Partner already defined as "<<My->WatPart<<
            " but still"<<endl; 
          cout<<"Define Watched Partner =# "<<i<<" = "<<NodePtr<< 
            " from WatchPartV "<<WatchPartV<<endl; 
          My->WatPart = NodePtr;
       } 
    } // end for i
    cout<<"Checked all cells are in tree, N="<<N<<endl;
    My->WatPart=NULL; // for debugging, means look at all partners
    My->WatchedCell = My->WatchedLLGCell; // no distinction here???
    cout<<"WatchedCell@"<<My->WatchedCell<<", WatchedLLGCell@"<<My->WatchedLLGCell<<endl;
#endif  //  DEBUG1
    cout<<"Call initRectPartners"<<endl;
    initRectPartners(NodePointers[0]->half);

    delete[] NodePointers;
    delete[] LDir;
    delete[] NumBins;
    delete[] CutPoint;
    delete[] First;
    delete[] NodeSize;
    delete[] MaxOrWid;
    delete[] MinPos;
    delete[] NumInBin;

} // end PutOnTree

// returns H, the m-static field, given M, the magnetizations.
// This H will not include exchange field or anisotropy components.
void CalcHfromM(real3* M, real3* H) {
    // TODO: final code shouldn't need these MVector conversions...

    for (CellIDType i=0;i<LLGcell::NextSmCellID;i++) {
		My->CellFromID[i]->M.SetToArray(M[i]);
	}

    My->root->updateMoment();
    My->root->SmoothField->SetToZero();
    My->root->updateStat();
	
    //#pragma omp parallel for shared(H) if(LLGcell::NextSmCellID>40)
	for (CellIDType i=0;i<LLGcell::NextSmCellID;i++) {
		for (short j=0;j<3;j++) {
			H[i][j] = My->CellFromID[i]->H_quad[j];
		}
	} // end for i
}  // end fn. CalcHfromM

void PrintCellsInfo(){
    int N1 = 30; 
    cout<<"Printing up to "<<N1<<" cells:"<<endl;
    for (CellIDType i=0;i<LLGcell::NextSmCellID;i++) 
    { cout<<"Pos: "<<My->CellFromID[i]->center<<" M: "<<My->CellFromID[i]->M<<
		" H: "<<My->CellFromID[i]->H_quad<<endl;
      if(i>N1) return;
    }
}
