#include "Lowest.h" // has iostream, math,..
#include "acfield.h"
#include "Systm.h" // for My
extern Systm *My;

ACPulsedField::ACPulsedField()
{
	mode = 0; 

	Hcos = (0.,0.,0.);
	Hsin = (0.,0.,0.);
	omega = 0.;
	omega_start = 0.; //AC pulse field circular frequency
	omega_end = 0.;
	omega_step = 0.;
	theta = 0.; //initial phase of the AC pulse field
	StartTime = 0.; //start time
	TotalTime = 0.; //total time
}

ACPulsedField::~ACPulsedField()
{
}

void ACPulsedField::ReadAC(ifstream *File)
{
//	real Hcosx, Hcosy, Hcosz, Hsinx, Hsiny, Hsinz;
  
   *File>>mode>>Hcos>>Hsin>>omega_start>>omega_rate>>theta;
   switch (mode) {
	   case 0: 
		   mymode = Log;
		   break;
	   case 1:
		   mymode = Linear;
		   break;
	   case 2:
		   mymode = Constant;
		   break;
	   default:
		   cout<<"unrecognized SweepMode for ACField, exiting..."<<endl;
		   MYEXIT(2);
		   break;
   }

   omega = omega_start;

}

MVector ACPulsedField::GetACField()
{
		switch (mymode) {
			case Log:
				omega += omega_rate * omega * My->dt;
				break;
			case Linear:
				omega += omega_rate * My->dt;
				break;
			case Constant:
				break;
			default:
				cout<<"unrecognized SweepMode in ACField"<<endl;
				MYEXIT(7);
				break;
		}

		theta += omega * My->dt;
		cout<<"omega = "<<omega<<endl;
		return Hcos * cos(theta) + Hsin * sin(theta);
}
