#include "Lowest.h"
 // REMOVE some of these if possible
#include "Systm.h"
#include "cell.h"
#include "mpole.h"
#include "MVector.h"
#include "Outputs.h"

//#include <time.h>
#ifdef _GROUPS
#include "_Groups.h"
#endif

#define CONSOUTPUT 0
#define RELTOL (1.2e-7)

void Invert(real** input, short n, real** A); //instead of #include "invert.h"

Constrain::Constrain(short NC1)// constructor
{ 	
	NC=NC1;
	Prorating=0; //false; CalcMom.. first called just to calculate moments, don't mess with field
	// assert(NC==1); // for debugging
	i_=new short[NC];
	short ic=0; short i;
	cout<<"Creating constrain object, constraining modes ";
	for(i=1;i<=My->NModes;i++)
	{ assert(My->Modes[i]);
      if(My->Modes[i]->ConstrainIndex>-1) // means it's constrained
	    {My->Modes[i]->ConstrainIndex=ic; i_[ic++]=i; // postincrement, I hope
	     // failed: My->Modes[i]->MomFormat[0]='!'; // ! flags constrained vbl in display
#ifdef GRAPHICS
	    if(My->Modes[i]->MomDisp) My->Modes[i]->MomDisp->Prefix[0]='!'; // some won't be displayed
#endif
	     assert(i_[My->Modes[i]->ConstrainIndex]==i); // sanity check
		 cout<<My->Modes[i]->ModeName<<", ";
	    } 
#ifdef GRAPHICS
	  else 
		{ if(My->Modes[i]->MomDisp) My->Modes[i]->MomDisp->Prefix[0]=' ';
		  //My->Modes[i]->MomFormat[0]=' '; // no ! flag if unconstrained;
	      // don't need this if destructor works correctly!!     
          cout<<"&Unconstrained mode "<<My->Modes[i]->ModeName;
		   if(My->Modes[i]->MomDisp) cout<<", Prefix="<<My->Modes[i]->MomDisp->Prefix<<endl;
	    }
#endif
	}
	cout<<" only."<<endl;
	assert(ic==NC);
	dm=new real[NC];
	Dm=new real[NC];
	hStart=new real[NC]; hLineStart=new real[NC];
	mStart=new real[NC]; //mLineStart=new real[NC];
	mWant=new real[NC];
	dh=new real[NC];
	dDmdh=new real*[NC]; // need loop
	inver=new real*[NC];
	for(short ic=0;ic<NC;ic++) // finish 2-index arrays, initialize
	{  dDmdh[ic]=new real[NC]; inver[ic]=new real[NC];
	   i=i_[ic]; // why is this here??
	   // initialize later: dm[ic]=dh[ic]=0.0; // init dDmdh later
	}
/*
	if(My->DampingFinite)
	{cout<<"You specified finite damping ('Algorithm' line)."<<endl;
	  cout<<"That's inconsistent with constraints. I'll set FiniteDamping=0"<<endl;
	  cout<<"this once if you'll press a key, but change your script file"<<endl;
	  cout<<"so we don't have to have this conversation again."<<endl;
	  char ch; cin.get(ch); My->DampingFinite=0; // false
	}
*/
	Rectang* rec=My->WatchedCell->rect; assert(rec);
    MaxField=0.2/(rec->gadtM*rec->Ms);  // 0.2 is guess, 
	if(My->DampingFinite)
	{  real M1=0.2/rec->gdt;
	   if(M1<MaxField) MaxField=M1;
	}
 } // end constructor

Constrain::~Constrain()// destructor
{ 	
	// assert(NC==1); // for now
    delete dm; delete Dm; delete mWant;	delete dh;
	delete hStart; delete hLineStart; delete mStart; // delete mLineStart;
	for(short ic=0;ic<NC;ic++) // finish 2-index arrays, initialize
	{  delete dDmdh[ic]; delete inver[ic];
	   // My->Modes[i_[ic]]->MomFormat[0]=' '; // unflag it
#ifdef GRAPHICS
	if(My->Modes[i_[ic]]->MomDisp) My->Modes[i_[ic]]->MomDisp->Prefix[0]=' ';
#endif
	}
	delete dDmdh; delete inver;
	delete i_;
 } // end destructor

void Constrain::InitDms() // set dDmdh, Dm=0
{
	for(short ic=0;ic<NC;ic++) 
	{ Dm[ic]=0.;
      for (short jc=0;jc<NC;jc++)  dDmdh[ic][jc]=0.;
	}
}

bool Constrain::AdjustFields() // see how mode field should be changed
{  // already Calced Moments, dDmdh,Calc_dm; 
	//returns false if fails
	My->ConvSteps++;
   short i,j,I; CellIDType ic; 
   // invert_test(); // try out Gauss-Jordan 
   // cout<<"dDdmh="; pinta(dDmdh,NC,NC);
   Invert(dDmdh,NC,inver); // inverts; matrices already exist
   // cout<<"inv="; pinta(inver,NC,NC);
   // real Det=MatrixInverse(dDmdh,NC,inver); //shd be same esult
   // if (abs(Det)<1e-7) {cout<<"This isn't working!"<<endl; return 0;}
   if(!My->Repeat) cout<<
	   // "Determinant="<<Det<<
	   ", dm-Dm(w/o dh) & matrix * dh is"<<endl; 
   real Prorate=1.0; // might have to decrease dh by this factor to keep h<MaxField
   real h1, Pro1; // temporary 
   real size=0; // determine scale of matrix
   for(i=0;i<NC;i++) // loop constraints
   {  I=i_[i]; dh[i]=0.0; // notes (S)10.34xx+1r(can't find! See 10.3387?
      size+=fabs(dm[i]-Dm[i]); // size of vector, to compare to error
      for(j=0;j<NC;j++) dh[i]+=inver[i][j]*(dm[j]-Dm[j]); // new fields
	  if(!My->Repeat)
	  {
		  cout<<dm[i]<<" (-) "<<Dm[i]<<" = ";
		  for (j=0;j<NC;j++) cout<<dDmdh[i][j]<<" ";
		  cout<<"* "<<dh[i]<<endl;
	  }
	  //h1=My->Modes[i_[i]]->HVal; // My...HVal is current value of h[i]

	  // FIX 4/6/2013: now cap |h| at MaxField
	  h1 = My->Modes[I]->HVal; //bias by current h[i]
	  if(dh[i]>0.0) Pro1 = (MaxField-h1)/dh[i]; //distance to max
	  else if (dh[i]<0.0)  Pro1=(-MaxField- h1)/dh[i];
	  else Pro1=My->Infty;

	  // Pro1=(MaxField/abs(dh[i])); 
	  if (Pro1<Prorate) Prorate=Pro1; // find smallest
   } // end for i
   // sanity check, can comment out 6 lines
      real m1;
      for(i=0;i<NC;i++) // loop constraints
	  {  m1=0; 
         for(j=0;j<NC;j++) m1+=dDmdh[i][j]*dh[j];
		 //cout<<"About to compare "<<dm[i]-Dm[i]<<" & "<<m1<<endl;
         Pro1 = dm[i]-Dm[i]; // dummy
		 real frac = (Pro1-m1)/size; // fractional error
		 if(fabs(frac)>1e-5) cout<<"Error in matrix inversion "
			 <<frac<<" * "<<size<<"(scale) in ddm["<<i<<"]="<<Pro1<<endl;

//		 if((fabs(dm[i]-Dm[i]-m1)/size)>0.0001) // 0.0001 gave no errors
//		   cout<<"Error in matrix inversion,ddm["
//		 	 <<i<<"]="<<dm[i]-Dm[i]<<" ? "<<m1<<", rel. to "<<size<<endl; // new fields
	  }
   if(!Prorating) dm2=6e35; // if not previously prorating, don't evaluate progress
     // would be safer to set dm2=Float.NaN (or define real.NaN?)
   Prorating = (Prorate<1.0);
   	  if(Prorating) 
	  {   
		  if(!My->Repeat) cout<<"Capping mode field at "<<MaxField<<
	        ".  If persists, change MaxField, dt?"<<endl;
          real d2=0.0; // calc length of shortfall dm
		  for(i=0;i<NC;i++) d2+=dm[i]*dm[i]; // dm2 is old value
          if(!My->Repeat) cout<<"shortfall d2="<<d2<<", was "<<dm2<<endl;
		  if (My->ConvSteps>8) if(((dm2-d2)/d2)<0.001) 
			 // will trigger if dm increases or doesn't decrease fast enough
		    {cout<<"In AdjustFields: shortfall d2="<<d2<<", was "<<dm2<< "little progress, failure."<<endl; return 0;}
		    // trigger was 0.01, sometimes quits when shouldn't
		  dm2 = d2; // store as old value
		  //if (My->ConvSteps>10) {cout<<"Field of mode "<<I<<" capped too long."<<endl;
	      //  cout<<"Not converging. May want to decrease dt?"<<endl;
		  //	if(My->CBMode==My->STEP) return 0;} // if RUN, may just decrease field	
		  //  if(Prorate<1e-10) {cout<<"Singular point? Maybe isn't working"<<endl; return 0;}
		  //   if(My->ConvTask==My->STEP) return 0;}
	  } else
		  if(!My->Repeat) cout<<"Not prorating"<<endl;

	  for(i=0;i<NC;i++) {dh[i]*=Prorate; My->Modes[i_[i]]->HVal+=dh[i];} // actually prorate
   //OLD: for(i=0;i<NC;i++) My->Modes[i_[i]]->HVal+=dh[i]*Prorate;
	 
   for (ic=0;ic<LLGcell::NextSmCellID;ic++) //  loop smallest cells, fix H_lin
   { 
	   LLGcell* c1 = My->CellFromID[ic];
       My->CalcShapeFCell(c1);
       for(j=0;j<NC;j++) 
	   {  Mode* M1=My->Modes[i_[j]];
		   MVector H1=M1->ShapeF*dh[j]/c1->volume();
	       if(M1->NonField) H1=c1->M^H1; // spin torque
		   c1->H_lin+=H1;
	      // can't use ModeField here, adds all of HVal, we want part dh
	   } // end for j
   } // end for ic

   if(!My->Repeat) // in pause mode, might be able to read this:
   {  cout<<"Apply constrained fields h=";
      for(j=0;j<NC;j++) cout<<My->Modes[i_[j]]->HVal<<", ";
	  cout<<endl;
   }
   return 1;
} // end AdjustFields()

void   Constrain::CalcMoments_dDmdh() // calc. MVal, ddEdh, Dm
{ // assumes H_lin, H_quad known from UpdateStat (sum=H_av)
   // loop over modes: set dm/dh, MVal = 0
	// rationale for this: 10.337 in Landscape (S) #d pages 
	EXIT1("CalcMoments_dDmdh NOT fixedyet"); // remove this function, but now it's called
	// by GridCB
/*	CellIDType i;
	short im,jm; real Ms2;
	Mode* IM;
	MVector H1; // total field
	real MFi; // M dot F
	for(im=0;im<NC;im++) 
	{   My->Modes[i_[im]]->MVal=0.0; // initialize moment
	    Dm[im]=0.;
		for (jm=0;jm<NC;jm++) dDmdh[im][jm]=0.0;
	} // end for im
    if(!My->Repeat) cout<<"In Calc..dDmdh; "; 
	//NO:  if(Prorating) cout<<"prorating, remove HVal"<<endl;
	           //else cout<<"not prorating"<<endl;}

   for (i=0;i<LLGcell::NextSmCellID;i++) 
   { // this is only over SMALLEST cells
	   LLGcell* c1 = My->CellFromID[i];
	   real gg=c1->rect->gadtM; // for short
       My->CalcShapeFCell(c1);
 	   H1=c1->H_av(); // from H_lin
       for(im=0;im<NC;im++) 
	   {  IM=My->Modes[i_[im]];
	      MVector* Fi = &IM->ShapeF; // to avoid actually copying vector
	   	  IM->MVal+= *Fi*c1->M; // actual moment
	      Ms2=c1->rect->Ms*c1->rect->Ms;
		  MFi=c1->M*(*Fi); //Dm is also calc in CalcDelM..
		  // this is BAC-CAB, (FH)(MM)-(FM)(MH)
		  // real MH=c1->M*H1; real FH=Fi*H1; real FHMs2=FH*Ms2; real MFMH=MFi*MH;// debug
		  Dm[im]+=gg*(((*Fi*H1)*Ms2) - MFi*(c1->M*H1));
		  //cout<<" calc Dm["<<im<<"]="<<Dm[im]<<endl;
		  for (jm=0;jm<NC;jm++)
	      { MVector *Fj = &My->Modes[i_[jm]]->ShapeF;
             dDmdh[im][jm]+=gg*
			  (((*Fi*(*Fj))*Ms2)-(MFi*(*Fj*c1->M)))/c1->volume();
	      }
	   } // end for im
   } // end for i
   // NO! if Prorating, now don't need dh in HVal; removed effects on H_lin above.
   // NO! if(Prorating) for(im=0;im<NC;im++) My->Modes[i_[im]]->HVal-=dh[im]; 
   // now it's like HVal never had its large value, except it moved M's
*/
} // end function CalcMoments_dDmdh
   
bool Constrain::Calc_dm() // returns 1 if large discrep
{  // real max=0.; 
   Mode* IM; bool Far=false; //assumes MVal is known
   for (short im=0;im<NC;im++) // how far from desired moments?
   {  IM=My->Modes[i_[im]]; // mode pointer
      dm[im]=mWant[im]-IM->MVal;
	  if(!My->Repeat) cout<<"Calc_dm,im="<<im<<": dm="<<dm[im]<<
		  "= want("<<mWant[im]<<")- got "<<IM->MVal<<endl;
      if(abs(dm[im])>IM->Tol) Far=1; // true
   } 
   return Far; // max discrepancy
}
bool Constrain::hConverged()
{  Mode* IM; real hTolToUse;
   for (short im=0;im<NC;im++) // loop constrained modes
   { IM=My->Modes[i_[im]]; // mode pointer
     hTolToUse = 2.0*IM->MMax*My->MachineAcc; // so far, roundoff in moment (2 is fudge)
	 //cout<<"in hConverged, mode "<<IM->ModeName<<", moment roundoff="<<hTolToUse<<",";
	 hTolToUse/= abs(dDmdh[im][im]);// use diagonal element of dDmdh to estimate effect of h
	 //cout<<", giving hTol="<<hTolToUse<<","<<endl<<"   you asked for "<<My->hTol<<", use larger, ";
	 if(My->hTol>hTolToUse) hTolToUse=My->hTol; // use the larger Tol
	 //cout<<hTolToUse<<", vs. dh="<<dh[im]<<endl;
	 // used to just use hTol, but this may be unrealistically small
     if (abs(dh[im])>hTolToUse) return false; 
   }
   return true; // all < Tol
} 

/*
void Constrain::SavehLineStart()
{ for (short i=0;i<NC;i++) {hLineStart[i]=My->Modes[i_[i]]->HVal;}
      // mLineStart[i]=mWant[i]; no!
}
void Constrain::SavehmStart()
{ for (short i=0;i<NC;i++) {hStart[i]=My->Modes[i_[i]]->HVal;
      mStart[i]=mWant[i];} 
}
void Constrain::RestorehLineStart()
{ for (short i=0;i<NC;i++) {My->Modes[i_[i]]->HVal=hLineStart[i];}
      // mWant[i]=mLineStart[i]; DON"T restore *step2ptr!
}
void Constrain::SaveH(real* H1) // saves to H1
{ for (short i=0;i<NC;i++) H1[i]=My->Modes[i_[i]]->HVal;
}
void Constrain::RestoreH(real* H1)
{ for (short i=0;i<NC;i++) My->Modes[i_[i]]->HVal=H1[i];
}
*/
void GridPt::SaveH() // saves to GridH
{ for (short Dir=0;Dir<2;Dir++) GridH[Dir]=My->Modes[My->GridInf1->GridMode[Dir]]->HVal;
}
void GridPt::RestoreH()
{ for (short Dir=0;Dir<2;Dir++) My->Modes[My->GridInf1->GridMode[Dir]]->HVal=GridH[Dir];
}

void Constrain::SetConsH0()// sets mode fields = 0 
{  for(short i=0;i<NC;i++) My->Modes[i_[i]]->HVal=0.0;
} 
/*
void Constrain::SetmWant(real* H1)// sets mWant=them
{  cout<<"Setting "<<NC<<" constrained moments "<<endl;
   for(short i=0;i<NC;i++) mWant[i]=H1[i];
}*/

void Constrain::SetmWantToPresent()// calcs present moments, sets mWant=them
{  My->CalcMoments(); // just need Moments MVal
   cout<<"Setting "<<NC<<" constrained moments to present values"<<endl;
   Prorating=false; // do this whenever reset mWant
   for(short i=0;i<NC;i++) mWant[i]=My->Modes[i_[i]]->MVal;
}

/*
void Constrain::SetmWantToIndices()// sets mWant from ig[.]
{  cout<<"Setting GridMode constrained moments from indices"<<endl;
   Prorating=false; // do this whenever reset mWant??
   //for(short i=0;i<NC;i++) mWant[i]=My->Modes[i_[i]]->MVal;
   for(short Dir=0;Dir<2;Dir++)
	   mWant[My->Modes[My->GridInf1->GridMode[Dir]]->ConstrainIndex]
          =My->GridInf1->GetM(Dir,My->GridInf1->ig[Dir]);
   cout<<"Set mWant="<<mWant[0]<<", "<<mWant[1]<<
			  " from indices "<<My->GridInf1->ig[0]<<", "<<My->GridInf1->ig[1]<<endl;
}
*/

void GridInfo::SetmWantToIndices()// sets mWant from ig[.]
{  // cout<<"Setting GridMode constrained moments from indices"<<endl;
   My->cons->Prorating=false; // do this whenever reset mWant??
   //for(short i=0;i<NC;i++) mWant[i]=My->Modes[i_[i]]->MVal;
   for(short Dir=0;Dir<2;Dir++)
	   My->cons->mWant[My->Modes[GridMode[Dir]]->ConstrainIndex]
          =GetM(Dir,ig[Dir]);
   cout<<"Set mWant="<<My->cons->mWant[0]<<", "<<My->cons->mWant[1]<<
			  " from indices "<<ig[0]<<", "<<ig[1]<<endl;
}

GridInfo::GridInfo() // constructor
{   // not clear we need this 
	F1L=MFile=HFile=AstFile=NULL; 
}

void GridInfo::GridAlloc()
{
  CrashFlag=(GridPt*) &NGrid; // randomly chosen pointer
  GridPts=new GridPt**[NGrid[0]];
  if (!My->cons) EXIT1("You must set up constraints to make a grid");
    // used in constructor GridPt()
  cout<<"Constructing a "<<NGrid[0]<<"x"<<NGrid[1]<<" grid, ("<<GetM(0,0)<<" to "
	 <<GetM(0,NGrid[0]-1)<<") by ("<<GetM(1,0)<<" to "<<GetM(1,NGrid[1]-1)<<")."<<endl;
  for (short i0=0;i0<NGrid[0];i0++) // 
  {   GridPts[i0]=new GridPt*[NGrid[1]];
      for (short i1=0;i1<NGrid[1];i1++) GridPts[i0][i1]=NULL;//was (GridPt*)NULL;
  }   // null means not tried yet
  dhdm=new real*[2]; // make 2x2 matrix
  for (short i=0;i<2;i++) dhdm[i]= new real[2];
}

GridPt::GridPt() // constructor; NC is # constrained
{ GridH=new real[2]; // was [My->cons->NC]; needn't initialize? 
  // GridM = new real[My->cons->NC]; 
}
GridPt::~GridPt() // destructor;
{ delete GridH; //delete GridM;
}

real GridInfo::GetM(short Dir, short i)
{  return GridMin[Dir]+GridInc[Dir]*i;
}

short GridInfo::GetIndex(short Dir, real M1)
{  return (short) floor(((M1-GridMin[Dir])/GridInc[Dir])+0.5);
}

void GridInfo::ReadGrid(ifstream& inf)
{
	  // 10/2012 I do NOT know why we need BigExchEn (could use ELimit?)
	  real BigExchEn=15*My->RectFromID[0]->RoughExchEn(); // use where angle large
	    // 15 is fudge factor
	  cout<<"WHY do we need BigExchEn? = "<<BigExchEn<<endl; // cin.get();

	  short Dir=0; // counts axes
	  short IM; real M1;
	  string junk, st1; char ch;
      getline(inf,junk); inf>>ws; // skip white space
      My->CheckScript(junk, "Grid");
	  cout<<"Grid block:";
      while((ch = (char)inf.peek()) != '!')  //inner nested while loop
      {  cout<<ch; // debug
         switch(ch)
          {
            case '#':
              break;
			case 'A': // write astroid file
			  My->CheckScript(junk,"Astroid");
              AstFile = new ofstream; // create now to warn user if in use
              AstFile->open((My->ScriptDir+My->runID+".Ast.csv").c_str());
              if (!AstFile->is_open()) {cout<<"can't open astroid file *.Ast.csv"<<
	             " -- is it in use?"<<endl; MYEXIT(55);}
			  break;
			case 'B': // bad points
		      inf>>junk>>st1; My->CheckScript(junk,"BadPoints");
			  Blanks = st1[0]=='B';
			  cout<<"Fill bad points with";
			  if(Blanks) cout<<"blanks"; else cout<<"EnergyLimit"; cout<<endl;
			  break;  
			case 'D': // detailed log; if fails to open it's ok, won't write
              inf>>junk;
			  My->CheckScript(junk,"DetailedLog");
              if(!F1L) F1L=new ofstream; // for debugging
	          F1L->open((My->ScriptDir+My->runID+".Log1.txt").c_str());
	          if(F1L) *F1L<<"This is log file 1; "<<endl<<
		  "$5.6e9 means this is energy"<<endl<<
		  "|8,1 means starting convergence at 8,1,"<<endl<<
		  "! means end of left-right path because AdjustField failed "<<endl<<
		  "> means end of path due to angle or energy too big (similar to !)"<<endl<<
		  "* means end of path due to hitting boundary or previously visited point"<<endl<<
		  "=Low@9,4 means this converged config. MAY be low, is temporarily saved to MC1"<<endl<<
		  "Pop@4,5 of 3 means pop (delete) the nest at 4,5 which is one of 3."<<endl<<
		  "Push 6,7-now 4 means create a nest at 6,7, now have 4 nests"<<endl<<
		  "Rest. 6,7 means restore the saved config. (nest) at 6,7"<<endl<<
		  endl;
			  else cout<<"************   Log file failed to open  ************"<<endl;
			  break;
            case 'm': // mode for one axis
	          inf>>junk>>st1; // modeName & new value
	          if(!inf) 
	         {cout<<"Error reading mode to step2, "<<junk<<st1<<endl; MYEXIT(26);}
	          IM=Mode::ModeNamed(st1); 
	          if (!IM) {cout<<"Error reading name of mode to step2:"
		        <<st1<<" is not a mode name"<<endl; MYEXIT(29);}
              GridMode[Dir]=IM;
			  M1=My->Modes[IM]->MMax;
              inf>>GridMin[Dir]>>GridMax[Dir]>>GridInc[Dir]; // read rest of line
			    // as read in, these are fractions; multiply by max value:
	          GridMin[Dir]*=M1; GridMax[Dir]*=M1; GridInc[Dir]*=M1; 
			  NGrid[Dir]=(int) floor(1.0001+((GridMax[Dir]-GridMin[Dir])/GridInc[Dir]) );
			    // 1.001 to allow for small roundoff error & still keep all points
			  assert(GridMin[Dir]<=GridMax[Dir]); assert(GridInc[Dir]>0); // sanity
			  if (NGrid[Dir]>1000) {cout<<"Big grid: "
				  <<NGrid[Dir]<<" points in direction "<<Dir<<" press key"<<endl;
			      cin.get();}
			  cout<<"Read grid mode, Dir="<<Dir<<", GridMin="<<GridMin[Dir]<<
				  ", Max="<<GridMax[Dir]<<", inc="<<GridInc[Dir]<<endl;
			  Dir++; // ready for next mode
			  break; // end case 'm'
			case 'E': // energy limit
              inf>>junk>>ELimit;
			  My->CheckScript(junk,"EnergyLimit");
			  break;
			case 'F': // field surface E(H)
			  My->CheckScript(junk,"Field_Surface");
              HFile = new ofstream; // create now to warn user if in use
			  HFile->open((My->ScriptDir+My->runID+".EvsH.csv").c_str());
			  if(!HFile->is_open()) {cout<<"Can't write file *.EvsH.csv"<<
		           "-- is it in use?"<<endl; MYEXIT(58);}
			  break;
			case 'c': // construct grid
			  inf>>junk; // doesn't matter
			  My->CheckScript(junk,"construct");
			  if(Dir!=2) {cout<<"Must specify 2 axes for grid before construct"
				  <<endl; MYEXIT(33);}
              GridAlloc();
			  break;
			case 'O': // Origin matrix (open file here; make matrix at end)
		      inf>>junk; My->CheckScript(junk,"OriginMatrix");
	          MFile = new ofstream; // not needed til end, but warn user now if can't create
	          MFile->open((My->ScriptDir+My->runID+".Matrix.csv").c_str());
	          if(!MFile->is_open()) {cout<<"Can't write file *.Matrix.csv"<<
		           "-- is it in use?"<<endl; MYEXIT(38);}
              break;
#ifdef _GROUPS // don't bother with .inc here now
			case 'P': // project onto 4-fold group 
			{  
           if(!My->NH) {cout<<"No 4-fold groups to project!"<<endl; MYEXIT(39);}
           inf>>junk>>st1>>My->NH->ProjToGp; My->CheckScript(junk,"Project_4fold");
			  My->NH->ProjToNes=My->NH->NesNamed(st1);
	    	  if(My->NH->ProjToNes==My->NH->Nestings.end()) // flag for error return
			    EXIT1("Can't find nesting to project");
			  assert(My->NH->ProjToGp>0); assert(My->NH->ProjToGp<=MaxGens);
			} // end case 'P'
         break;
         case 'p': // project using general rotations
         { if(!My->SymH) {cout<<"No symmetry lP to project!"<<endl; MYEXIT(49);}
           char ch1;
           inf>>junk>>IM>>ch1; My->CheckScript(junk,"project_configs");
           bool odd1=(ch1=='-');
           std::list<Symmetry>::iterator sit=My->SymH->FindSym(IM,odd1);
           //if(sit==My->SymH->Symmetries->end) {cout<<"Couldn't find symmetry l="
           sit->usage=sit->ProjTo; // as opposed to ProjectOut or Ignore
         } // end case p
	      break;
#endif !_GROUPS
	/*		 CAN'T	do this here!! after leaving this GRID block, will never get back in. 
	       If you want special commmand to calc astroid, it needs to be in ReadScript2().
	       case 'a': // calculate astroid
			  inf<<junk; assert(junk[1]='s');
			  CalcAstroid(); // has no graphics yet
			  break;
   */
            default:
              //cout<<"Error in Grid block"<<endl;
			  getline(inf,junk);
			  cout<<"Error in Grid block of script file, at line:"<<junk<<endl; MYEXIT(44);
            } //end of inner G switch
		 	if(!inf) {cout<<"Error in script, Grid block, near:"
	        	 <<junk<<endl; MYEXIT(22);}

          getline(inf,junk,'\n');
	      inf>>ws; // skip white space at beginning of next line
        } //end of inner Grid while loop, shd be at !
      // leave end of its line for getline(inf,junk) to read
      // assert(junk[0] == '!');
	  // end of GRid block, now open file (always want)
	  // this was case 's', but has to be at the end anyhow:
			
	for(short Dir=0;Dir<2;Dir++) 
		{  // get index from present MVal
			ig[Dir]=GetIndex(Dir,My->Modes[GridMode[Dir]]->MVal);
			if(ig[Dir]>NGrid[Dir]-1) ig[Dir]=NGrid[Dir]-1; // limit it above
			if(ig[Dir]<0) ig[Dir]=0; // limit it below
	    }
			SetmWantToIndices(); // uses ig
			cout<<"GetIndex got "<<ig[0]<<", "<<ig[1]<<" from moments MVal"<<
				", from them mWant="<<My->cons->mWant[0]<<","<<My->cons->mWant[1]<<endl;

			NeedNewPt=false; // we just set up point
			ForceSave=true; // save 1st point; if turned on, stays true until saved
			My->CBMode=My->GRID; // launches grid traversal
			My->NextDisp=1; // display everything at first, as tho just converged
			My->ConvSteps=0; PrevE=9e34; // so 1st energy looks low, will be saved
            PrevLow=false; // so we won't try to save nonexistent point

 /* No longer save to StartConfigs here -- will do that in algorithm because PrevLow=true.
       Use ig, M, directly.
            // set temp. metaconfig MC1 to present config (created by user):
            MC1.LowCon.saveM(); // neededn't save fields, they are already set
			  // & will be refined and saved after convergence at this ig.
			MC1.ind[0]=ig[0]; MC1.ind[1]=ig[1];
			StartConfigs.push_back(MC1); 
			cout<<"Saved initial Config,@"<<StartConfigs.begin()->ind[0]<<", "
				<<StartConfigs.begin()->ind[1]<<" as StartConfig"<<endl; 
*/
			// now return to ReadScript2, thence return from callback
} // end ReadGrid

void GridInfo::CalcAstroid() // called from GridCB
{
	short i0,i1,di0,di1,I,J; // for loops, instead of ig[Dir]
	real Sign[2]; real Det0, Det1, Frac, Frac1; // determinant
	real Ast1, Ast0;
	GridPt *GP, *GL;
   // Loop grid to calculate dhdm and determinant for each plaquette center;
   // also average GridH at center, store all at lower left.
   for (J=0;J<2;J++) for (I=0;I<2;I++) dhdm[I][J]=0.0; // initialize
   for (i0=0;i0<NGrid[0]-1;i0++) // quit early so entire plaquette known
   {   cout<<"In CalcAstroid, i0="<<i0<<endl;
       for(i1=0;i1<NGrid[1]-1;i1++)
	   {  // could use 4 pairs of lines like this:
	     //dhdm00 = (GridPts[i0+1][i1]->GridH[0]-GridPts[i0][i1]->GridH[0]+
		     //GridPts[i0+1][i1+1]->GridH[0]-GridPts[i0][i1+1]->GridH[0])/GridInc[0];
         GL=GridPts[i0][i1]; //lower left of plaquette, use to store stuff
		 if(GL) // could comment out 3 cout lines
		 {  cout<<endl<<"Plaquette w/GL @"<<i0<<","<<i1;
		    if(GL==CrashFlag) 
			{   
				cout<<", but CrashFlag! New i1."<<endl;
				continue; // increment i1 loop, try new (i0,i1)
			}
			cout<<", E="<<GL->GridE<<endl;
		 }
		 else continue; // next point if GL=NULL
	     Sign[1]=-0.5; // index=gradient direction; sign=-1 for di1=0, 
         for (di1=0;di1<2;di1++)      // include factor 1/2 for average
	     {  Sign[0]=-0.5; // for di0=0
	        for (di0=0;di0<2;di0++) // loop 4 corners
	        {  GP=GridPts[i0+di0][i1+di1]; // a corner of plaquette
			   cout<<"Corner # "<<di0<<","<<di1<<" @ "<<i0+di0<<","<<i1+di1;
			   if(GP==NULL || GP==CrashFlag) // incomplete data for plaquette
			   {  delete GL; GridPts[i0][i1]=NULL; // mark as useless
			      cout<<" -- useless, so plaquette is too!"<<endl;
			      // NO!! increments wrong loop!: continue; // increment i1 loop
                  goto DonePt; // done with this grid point
			   }
			   cout<<" has H="<<GP->GridH[0]<<","<<GP->GridH[1]<<endl;

	           for (I=0;I<2;I++) 
			   {  for (J=0;J<2;J++)// I=which comp of H; J =gradient directions
		  	         dhdm[I][J]+=Sign[J]*GP->GridH[I]/GridInc[J];
		      	  if(GL!=GP) GL->GridH[I]+=GP->GridH[I];  // VERY tricky; 
				  cout<<"accumulating H["<<I<<"], got "<<GL->GridH[I]<<endl;
			   }
			     // add 4 corners of plaquette and trust that you will 
			     // never use GL->GridH again because you've left it 
			     // behind in grid traversal
		       Sign[0]=0.5; // for di0=1
		    } // end for di0
            Sign[1]=0.5; // for di1=1
	     } // end for di1; got dhdm for this grid point
		 cout<<"Finished plaquette, average dh/dm matrix is:"<<endl;
		 cout<<"Calcd dhdm00="<<dhdm[0][0]<<" 01="<<dhdm[0][1]<<endl;
		 cout<<"          10="<<dhdm[1][0]<<" 11="<<dhdm[1][1]<<endl;
		 GL->Det=dhdm[0][0]*dhdm[1][1]-dhdm[0][1]*dhdm[1][0];
		 GL->GridH[0]*=0.25; GL->GridH[1]*=0.25; // now is AVERAGE over plaquette
		 cout<<"Avg H="<<GL->GridH[0]<<","<<GL->GridH[1]<<", Det="<<GL->Det<<endl;
DonePt:  GP=NULL; // placeholder to allow label DonePt!
           // use continue instead? NO! Jumps out of INNERMOST loop!
	   } // end for i1  
    }  // end for i0

   // now loop grid again (really plaquettes) to find astroid in M and H
   for (i0=0;i0<NGrid[0]-1;i0++) // quit earlier? so right & above plaquette known?
   {
       for(i1=0;i1<NGrid[1]-1;i1++)
	   {  // Det refers to point 1/2 cell up & right of i1,10!
		  GL=GridPts[i0][i1]; // lower left, but now also contains info about plaquette
		  if(!GL) break; // get next grid point i1
		  Det0 = GL->Det; 
	      if(i1+1<NGrid[1]-1) // if not, det can't exist at i1+1
		  {
		  GP=GridPts[i0][i1+1]; // interpolate between GL and GP, both plaquettes
		  if(GP)
		  {
		  Det1=GP->Det;
		  if(Det0*Det1<0) // changes sign, interpolate betw. (i0,i1) and (i0,i1+1)
		   {  cout<<"Found sign change in Det on vert. line between "<<
		         i0<<","<<i1<<" and "<<i0<<","<<i1+1<<endl;
			  Frac=Det0/(Det0-Det1); // fraction of way to 2nd point
		      Frac1=1-Frac; // weight of left point
			  Ast1=GetM(1,i1)+(0.5+Frac)*GridInc[1]; // interpolate
		      Ast0=GetM(0,i0)+0.5*GridInc[0]; // & displace
			  *AstFile<<Ast0<<d_<<Ast1;
			  Ast1=GP->GridH[1]*Frac1+GL->GridH[1]*Frac;  // now interp. H
			  Ast0=GP->GridH[0]*Frac1+GL->GridH[0]*Frac; 
			  *AstFile<<Ast0<<d_<<Ast1<<endl;
			
		   } // see 7/19/2012 notes for interpolation -- or re-derive.
		  } // end if(GP)
		  } // end if i1+1 exists
	      if(i0+1<NGrid[0]-1) // so plaquette GP might exist
		  {
		  GP=GridPts[i0+1][i1];
		  if(GP)
		  {
		  Det1=GP->Det;
		   if(Det0*Det1<0) // changes sign
		   {  cout<<"Found sign change in Det on horiz. line between "<<
		         i0<<","<<i1<<" and "<<i0+1<<","<<i1<<endl;
		      Frac=Det0/(Det0-Det1); // but different Det1 this time!
		      Frac1=1-Frac; 
			  Ast0=GetM(0,i0)+(0.5+Frac)*GridInc[0]; // interpolate
		      Ast1=GetM(1,i1)+0.5*GridInc[1]; // & displace, 
			  *AstFile<<Ast0<<d_<<Ast1<<endl;
			  Ast1=GP->GridH[1]*Frac1+GL->GridH[1]*Frac;  // now interp. H
			  Ast0=GP->GridH[0]*Frac1+GL->GridH[0]*Frac; 
			  *AstFile<<Ast0<<d_<<Ast1<<endl;
		   }
		  } // end if(GP)
		  } // end if i0+1 exists
	   } // end for i1  
    }  // end for i0
   AstFile->close();
   // write 
} // end CalcAstroid()

void GridInfo::WriteHFile()
{  short i0,i1; GridPt *G1;
   assert(HFile); // assumes HFile is open
   for (i1=0;i1<NGrid[1];i1++) 
   {  for(i0=0;i0<NGrid[0];i0++) // makes horizontal lines
	  {  G1=GridPts[i0][i1];
         if(G1) *HFile<<G1->GridH[0]<<d_<<G1->GridH[1]<<d_<<G1->GridE<<endl;
		 // for E(M) mesh: *MFile<<GetM(0,i0)<<GetM(1,i1)<<G1->GridE<<endl;
	  } *HFile<<endl; // blank line to terminate drawn line
	}
} // end WriteHFile 


void GridInfo::GridCB() // called to traverse grid
{  //upon entry, have displayed configuration
	// short Dir; 
	GridPt* G1; Config C1, C2;
	bool ConvergedMH;
GridCallback:
    if(!My->Repeat) cout<<endl<<"In GridCB, My->Repeat=false"<<endl; 
    if(NeedNewPt) // previously established need step along grid; 
		          // just displayed converged point
	{ //&&&&&&&&&&&&&&&&&&&
FindNewPoint:		
	NeedNewPt=0; 
    //cout<<"Repeat="<<My->Repeat<<endl; // visual studio seems to report wrong value for this!
	if(!My->Repeat) cout<<"Now at "<<ig[0]<<","<<ig[1]<<", need new point"<<endl;
	My->Restore_dt0();  
	// Now move point, preferably to right, then left, then up&down:
	ig[0]+=1; if(ig[0]<NGrid[0]) if (GridPts[ig[0]][ig[1]]==NULL) goto UseThisIG;
	// (NULL means haven't got there yet). If can't go right, then try left:
	ig[0]-=2; if(ig[0]>=0) if (GridPts[ig[0]][ig[1]]==NULL) goto UseThisIG;
	ig[0]+=1; // just returns to original value for test:
	if((ig[0]!=StartConfigs.begin()->ind[0]) || (ig[1]!=StartConfigs.begin()->ind[1]))
	{  // NOT at StartConfig, this path is done
	  if (F1L) *F1L<<"*";
	  if(!My->Repeat) cout<<"DIE,@ "<<ig[0]<<","<<ig[1]<<endl;

	  goto RestoreStartConfig; // also pushes back if PrevLow
	} // end if not at Start
	// only from StartConfig, try up and down (& force save):
	ig[1]+=1; if(ig[1]<NGrid[1]) if (GridPts[ig[0]][ig[1]]==NULL) {ForceSave=true; goto UseThisIG;}
	ig[1]-=2; if(ig[1]>=0) if (GridPts[ig[0]][ig[1]]==NULL) {ForceSave=true; goto UseThisIG;}
	// if you get here, you've tried all neighbors of StartConfig:
    if (F1L) *F1L<<"POP@"<<StartConfigs.begin()->ind[0]
	  <<","<<StartConfigs.begin()->ind[1]<<" of "<<StartConfigs.size()<<endl;
	cout<<"Pop config @"<<StartConfigs.begin()->ind[0]
	  <<", "<<StartConfigs.begin()->ind[1]<<" of "<<StartConfigs.size()<<" configs"<<endl;
	StartConfigs.pop_front(); // remove old config from list
	// My->Repeat=false; // DEBUG, to print more
	// Now use NEXT StartConfig:

	if(StartConfigs.empty()) 
	{  cout<<"Done with grid"<<endl;
	   if(My->XpoProd) My->Xport<<"BHmax="<<d_<<My->BHmax<<endl;
	   // write origin "matrix" (file was opened before grid calculated):
	  if(MFile) // could put the below in separate function!
	  {  assert(MFile->is_open()); // sanity
	    cout<<"Writing *.Matrix.csv file."<<endl;
	   for(short i1=0;i1<NGrid[1];i1++) // outer loop on y, rows
	    {
          for (short i0=0;i0<NGrid[0];i0++)
		  {  G1=GridPts[i0][i1];
		     if (G1==NULL || G1==CrashFlag) if(Blanks) *MFile<<' '; else *MFile<<ELimit;
			 else *MFile<<G1->GridE;
             *MFile<<d_;
		  }
		  *MFile<<endl;
	    }   
        MFile->close();
	  } // end if(MFile)
	  else cout<<"Not writing Matrix.csv file."<<endl;
		 
      if(HFile) WriteHFile();
	  if(AstFile) CalcAstroid(); // has no graphics, done after grid complete
      My->CBMode=My->READ_COMMAND;  // not GridCB anymore, done with grid
	  return; /// to main callback, to display last (failed?) config
	} // end if empty -- if get here,  
RestoreStartConfig: 
	  // get here because path ended: Energy/angle high, nonconvergence, 
	  // past grid boundary, hit previously-used points. 
	  // if prev. point seemed low, this isn't lower so it WAS a low. 
	  // Save it as StartCOnfig:

	  if(StartConfigs.empty()) EXIT1("StartConfigs empty -- start point bad?");

	  if(PrevLow) // it WAS a local minimum (this was SavePrevLow())
	  {  StartConfigs.push_back(MC1); // put in list
	     if (F1L) *F1L<<endl<<"Push "<<
		  MC1.ind[0]<<", "<<MC1.ind[1]<<", now "<<StartConfigs.size();
		 cout<<"Pushed back prev. config "<<MC1.ind[0]<<","<<MC1.ind[1]
		   <<", # configs= "<<StartConfigs.size()<<endl;
	  }
	  cout<<"About to restore Config, ind="<<StartConfigs.begin()->ind[0]
		    <<", "<<StartConfigs.begin()->ind[1]<<endl;
      StartConfigs.begin()->LowCon.restoreAnd(); // restore config
		   // could make fn MetaConfig::RestoreMeta(), but just called once.
	  ig[0]=StartConfigs.begin()->ind[0]; ig[1]=StartConfigs.begin()->ind[1]; 
   	  G1 = GridPts[ig[0]][ig[1]]; 
	  //cout<<"Restoring config at "<<ig[0]<<", "<<ig[1]<<", ptr="<<G1<<endl;
	  if(!G1) {cout<<"Bad starting point?"<<endl; MYEXIT(25);}
	    // shd have been here before, unless this is 1st point
	  G1->RestoreH();
	  PrevE=8e35; PrevLow=false; // no previous point known, let next be low
	       // would be safer to set =Float.NaN (or define real.NaN?)
	  if(!My->Repeat) cout<<"Using StartConfig at "<<ig[0]<<", "<<ig[1]<<endl; 
	  if (F1L) *F1L<<"Rest. "<<ig[0]<<","<<ig[1]<<endl;
      goto FindNewPoint; // steps from this point

		  // no path to here except jump
UseThisIG:
	if (F1L) *F1L<<"|"<<ig[0]<<","<<ig[1]; // terse
	if(!My->Repeat) cout<<"Stepped to "<<ig[0]<<","<<ig[1]<<endl;
	// now have a viable grid pt (ig) & starting config of nbr
	  SetmWantToIndices();
      My->ConvSteps=0;
	  if(My->cons) {My->cons->dm2 = 7e35;// needed only if(conv); check where else done
	  	       // would be safer to set =Float.NaN (or define real.NaN?)
	     My->cons->Prorating=false;} // make sure it doesn't subtract dh!
	  My->MaxDM = My->Infty; //was 999, so won't think you're converged
	     // would be safer to set =Float.NaN (or define real.NaN?)

	  NeedNewPt = false; // already have one
      if(My->NudgeMode) My->Modes[My->NudgeMode]->HVal=My->NudgeAmt; 
	    // start converging w/new fields
      My->Noise=true; // another nudge; will turn off after 1st evolve
	  if(!My->Repeat) cout<<"Start iterating, steps=0"<<endl;
      goto GridCallback;  
	    // top, with NeedNewPoint=false, to adjust fields for new config
	} //&&&&&&&&&&&&&&&&&&&   end need new point 

	else 

	{ //%%%%%%%%%%%%% don't need new point
       if(My->cons) // if some moments constrained
        {  
    // get here if loaded or calculated new configuration M, need dDmdh and Dm
		  My->cons->CalcMoments_dDmdh(); // get Dm too, deps on h. 
		    // Also undoes dh if Prorating.(DELETE! no longer)
		  //cout<<"Repeat="<<My->Repeat<<endl;
		  if(!My->Repeat)cout<<
			  "done CalcMoment"<<endl; // NOT "<< .. check H_lin, HVal removed!"

          // assume here know mWant (initialized or calcd)
          ConvergedMH = !My->cons->Calc_dm();  // returns 1 if dm large
		  if(!My->Repeat) {// don't fill output window if not pausing!
		     cout<<"moment ";if(!ConvergedMH)cout<<"not"; cout<<
		     " converged, MaxDM="<<My->MaxDM<<endl;}
		  // now check H converged too:
		  if(ConvergedMH) 
		  {  ConvergedMH = ConvergedMH && My->cons->hConverged();
		     if (!ConvergedMH) if(!My->Repeat)
		       cout<<"dh[0]="<<My->cons->dh[0]<<" NOT converged, > "<<My->hTol<<endl;
		  }
	      // req. small discrep. dm AND small rot. AND small dh, for convergence
		} // end if(cons)
	   else // nothing constrained
		   ConvergedMH=true; // vacuously, no convergence needed;not debugged though
		if (ConvergedMH && (My->MaxDM<My->DMTol) && !My->cons->Prorating) 
			// converged.  If Prorating, can't trust H, 
			// isn't real converged state (maybe saturated)
		{  // note this will NOT happen the 1st time, MaxDM init to infinity
			My->CalcEnergy(); 
			bool EnergyHi=My->IntEnergy>ELimit; 
			if (EnergyHi) cout<<"Energy "<<My->IntEnergy<<" high, >"<<ELimit;
			bool AngleBig=(My->MinCos()<My->CosLimit);
			if (AngleBig) cout<<" Nbr angle too big, ";
			if (EnergyHi || AngleBig) // point bad
			{  cout<<", Terminate Line."<<endl;
			   assert(!GridPts[ig[0]][ig[1]]);
			   if (F1L) *F1L<<">";
               GridPts[ig[0]][ig[1]]=CrashFlag; // store in array
			   goto RestoreStartConfig;
			} // end if point bad; here is good
               // cout<<"Converged, writing to file:"<<endl; 

/*  May not need to export data at all -- delete this some day.  
    But need calculate energy then!:   */
			if(!My->Repeat) cout<<"about to export data"<<endl;
            My->ExportData(true,true); // to both file & console, for now
			     // this calculates energy, which we save below
			cout<<"Converged, storing grid info at "<<ig[0]<<", "<<ig[1]<<
				   "& in file"<<endl;
			     // <<", ptr="<<GridPts[ig[0]][ig[1]]<<" shd=0,";

			assert(!GridPts[ig[0]][ig[1]]);
			if (F1L) *F1L<<"$"<<My->IntEnergy;
			G1= new GridPt; // didn't exist yet
			GridPts[ig[0]][ig[1]]=G1; // store in array
			// cout<<", new ptr="<<G1<<endl;
            // save to G1->GridH, GridE (needn't GridM?)
			G1->SaveH();
			G1->GridE = My->IntEnergy;
            bool ThisLow=G1->GridE<PrevE; // if not, previous was low & should be saved:
			if(ThisLow || ForceSave) // this could be min. E; save it
			   {  // could make function MC1->SaveMeta() with:
				 cout<<"Save config, energy "<<G1->GridE<<" may be low."<<endl; 
				 if (F1L) *F1L<<"=Low@"<<ig[0]<<","<<ig[1]; 
                 MC1.LowCon.saveM();
			     MC1.ind[0]=ig[0]; MC1.ind[1]=ig[1];
			   }
			//else // new energy bigger, if prev. was lowest before, still is:
				//SavePrevLow();
			if (((!ThisLow)&&PrevLow) || ForceSave)
			  // if prev was local min OR if ForceSave
			{  StartConfigs.push_back(MC1); // put in list
	           if (F1L) *F1L<<endl<<"Push "<<MC1.ind[0]<<", "<<
				   MC1.ind[1]<<", now "<<StartConfigs.size();
		       cout<<"Pushed back previous config "<<MC1.ind[0]<<","<<MC1.ind[1]
		         <<", # configs= "<<StartConfigs.size()<<endl;
			   ForceSave=false;
			}
			// Done with this point, ready to get next.
			PrevE = G1->GridE; PrevLow=ThisLow; // save for next time
			if(My->NextDisp) My->NextDisp=1; // NOW reset it, after writing
            NeedNewPt=true; 
			cout<<endl; // just to mark end of convergence process
			return; // exit callback to display 
		} // end if converged...
		else // not converged
		{
        if(My->cons) 
		  if((!My->cons->AdjustFields()) ||(My->ConvSteps>My->MaxIters)) // if can't adjust
			  // AdjustFields gets new mode fields HVal & fixes H_lin  
		    {  if(F1L) *F1L<<'!';
		       GridPts[ig[0]][ig[1]]=CrashFlag; // store in array
			   if(My->ConvSteps>My->MaxIters) cout<<My->ConvSteps<<" iterations; too many, RestoreStartConfig"<<endl;
			   // other case: if AdjustFields failed, user was told about it.
			   goto RestoreStartConfig;
		    }
        // if we get here, field adjustment worked.
		//if(!My->Repeat) cout<<"Evolve from M(cell#0)="<<My->CellFromID[0]->M<<
		//	", M(cell#1)= "<<My->CellFromID[1]->M<<endl;
#ifdef _GROUPS
		if(My->NH) if(My->NH->ProjToGp) // if can project
	    if(!(My->NH->ProjToNes==My->NH->Nestings.end()))
			// want to project to symmetry
		{ C1.saveM(); C2=My->NH->ProjToNes->Project(C1,My->NH->ProjToGp);
		  C2.restoreAnd(); // save to C1, project, restore
		}
#endif !_GROUPS

	    My->evolve(); // main event!
		//if(!My->Repeat) cout<<"to "<<My->CellFromID[0]->M
		//	<<" & "<<My->CellFromID[1]->M<<endl;
		// Next 2 lines are for safety -- don't use noise or nudge:
		My->Noise=false; // noise,mode may have been nudged 1st time: turn off
		if(My->NudgeMode) {My->Modes[My->NudgeMode]->HVal=0.;} 
		My->ConvSteps+=1;
#ifdef GRAPHICS // decide about displaying
		if(My->DisplayConv) // special scheme for showing 1st few iters.
		{
		  if(My->ConvSteps<My->NextDisp) goto GridCallback; // to top, if not display
		  if(My->NextDisp>My->d) My->NextDisp+=My->d; // cap increase at d
		  else My->NextDisp*=2; // display only powers of 2, if NextDisp>0 
		     // (triggered by d>1)
		}
		else // regular display interval control by 'd':
			if(!My->DisplayTime) goto GridCallback;
#else
		goto GridCallback; // always if no graphics
#endif
		} // end else not converged
		// from here, break; // exit case STEP, & display
	} //%%%%%%%%%%%%%%%%%% end else not NeedNewPt
    // return, display config
} // end GridCB()

MetaConfig::MetaConfig() // constructor
{ //ModeH=new real[My->cons->NC]; unnecessary functions?
  // LowCon is not pointer, automatically constructed
}

MetaConfig::~MetaConfig() // destructor
{ //delete ModeH;
  // LowCon is not pointer, automatically deleted?
}
