#ifndef CONS_H
#define CONS_H
#include "MVector.h" // lower level
//#include "Lowest.h"
#include "config.h"
#include <fstream>

class Constrain
{
   public:
   short NC; // supersedes Mode::NConstrained, but 
     // want it in this class.
   short* i_; // index array,i_[i]=i'th constrained mode
  // this is very preliminary, just does 1 constrained variable.
	   // eventually matrices will be Nx NC 
   real** dDmdh,**inver;
   real *dm,*dh,*mWant, *Dm;//Dm is DeltaM,dm is mWant-mGot 
   real *hStart,*hLineStart,*mStart; // no *mLineStart;
   bool Prorating;
   real MaxField;
   real dm2; // length of shortfall dm
   //Config *MOld;
   //member functions
   Constrain(short); // constructor
   ~Constrain(); // destructor
   void InitDms();
   bool AdjustFields();
   void CalcMoments_dDmdh();
   bool Calc_dm(); // returns 1 if far off
   bool hConverged();
   //void SavehLineStart(); void SavehmStart();
   //void Constrain::RestorehLineStart(); void Constrain::RestorehmStart();
   //void Constrain::SaveH(real* H1); 
   //void RestoreH(real* H1);

   void SetConsH0(); // sets HVal=0
   //void SetmWant(real* H1);
   void SetmWantToPresent(); // calcs present moments, sets mWant=them
   // void SetmWantToIndices();
};

class GridPt
{ public:
real *GridH; // first used index<NC (only constrained modes saved)
             // COULD change this to mode index<=NModes, save all???
             // but now only grid directions(2) stored.
// real *GridM; // do we need this at all? INdices determine M
real GridE;
real Det; // determinant of dm/dh
GridPt(); // constructor, create only if successful convergence
~GridPt();
void RestoreH();
void SaveH();
};

class MetaConfig // StartConfigs is a list of these
{   // so called because it has a little more info than "config"
public:
   short ind[2]; // address in grid point array
   // real *ModeH; this is stored in GridPt!
   Config LowCon; // can get moments from this, need no ModeM?
   MetaConfig(); // constructor
   ~MetaConfig(); // destructor
   // void SaveMeta(); //saves present M's to this object
   // void RestoreMeta(); //restores this to cell->M's
};

class GridInfo
{  public:
   ofstream *F1L; // only create, in ReadGrid, if need debugging
   ofstream *MFile,*HFile,*AstFile; // for matrix
   bool NeedNewPt, Blanks;
   real ELimit;// max energy, stops advancing there
   real BigExchEn; // used at 
   std::list<MetaConfig> StartConfigs;
   // std::list<MetaConfig>::iterator Config1; // just StartConfigs.begin()!
   short NGrid[2]; // size of grid
   real GridMin[2]; real GridMax[2]; real GridInc[2];
     // note GridMin+NGrid*GridInc = GridMax +GridInc; NOT GridMax.
   short GridMode[2]; // modes of axes
   GridPt ***GridPts; // 2D array of grid points
   // GridPts[i0][i1] null if not tried, CrashFlag if no convergence
   // GridPt *GridLine; // what for?
   GridPt *CrashFlag; // no convergence
   short ig[2]; // index in the grid of current point
   bool PrevLow; // previous point in line possible local min.
   bool ForceSave;
   real PrevE;
   real **dhdm; // curvature matrix
   MetaConfig MC1; // big thing, NOT pointer. temporary storage
   GridInfo(); // constructor
   void GridAlloc(); // constructs array GridPts
   void ReadGrid(ifstream&);
   real GetM(short Dir,short i); // map index i to moment value
   short GetIndex(short Dir,real M1); 
   //void SavePrevLow();
   void WriteHFile(); // could hae WriteMFile as well
   void CalcAstroid();
   void GridCB();
   void SetmWantToIndices();
};
#endif // ifndef CONS_H
