#include <stdlib.h>
#include <string.h>
//#include <cmath>
// #include <math.h>
#include "Lowest.h" // has iostream,cmath,assert
// #define Z 8
//using namespace std;
//#include <iostream>
/* unused
void pinta(real **A, int rows, int cols)
{
        int i,j;
        for (i=0;i<rows;i++)
        {  for (j=0;j<cols;j++) cout<<A[i][j]<<" "; 
           cout<<endl; // printf("\n");
        }     
}
*/

/* See pg 106 Kernighan & Ritchie (Prentice Hall) */
void swap(real *px, real *py)
{
        real tmp;        
        tmp=*px;        
        *px=*py;        
        *py=tmp;        
}
/* Gauss-Jordan */
/* http://www.cs.caltech.edu/courses/cs171/c2-1.pdf */
/* Original method solves Ax=B and B is not necessarily the Identity as here is        */
/* real** Inverse(real** A, int n, real** B, int m)                                 */

// Note Invert does not return determinant; if wanted that, could have DoDets(N) class 
// that sets up scratch 1x1, 2x2...NxN matrices, then Det(matrix) would loop i, copy
// cofactor matrix to scratch(N-1xN-1), add M_1i*Det(scratch) to Sum. NOt that hard.
void Invert(real** input, short n, real** A)
{
        real **b;
        short i,j,k,l,ll,*indxc,*indxr,*ipiv,m=n;
		short icol=0,irow=0;
        real big,dum,pivinv;
		b=new real*[n];
        for (i=0;i<n;i++)
		{
			b[i]=new real[n];
			for (j=0;j<n;j++) {b[i][j]=0.0; A[i][j]=input[i][j];}
			b[i][i]=1.0; // identity
		}
        indxc=new short[n]; // malloc(n*sizeof(int));
        indxr=new short[n]; // malloc(n*sizeof(int));
        ipiv=new short[n]; //malloc(n*sizeof(int));
        for (j=0;j<n;j++)
                ipiv[j]=0;
        for (i=0;i<n;i++)
        {
                big=0;
                for (j=0;j<n;j++)
                {
                        if (ipiv[j]!=1)
                        {
                                for (k=0;k<n;k++)
                                {
                                        if (ipiv[k]==0)
                                        {
                                                if (fabs(A[j][k])>=big)
                                                {
                                                        big=fabs(A[j][k]);        
                                                        irow=j;
                                                        icol=k;
                                                }
                                        }
                                }
                        }
                }
                ++(ipiv[icol]);
                if (irow!=icol)
                {
                        for (l=0;l<n;l++)
                                swap(&A[irow][l],&A[icol][l]);
                        for (l=0;l<m;l++)
                                swap(&b[irow][1],&b[icol][l]);
                }
                indxr[i]=irow;
                indxc[i]=icol;
                if (A[icol][icol]==0) 
				{	cout<<"Error: singular matrix"<<irow<<","<<icol<<endl;
				    MYEXIT(33);
				}
                else
                        pivinv=1/A[icol][icol];
                A[icol][icol]=1;                
                for (l=0;l<n;l++)
                {
                        A[icol][l]=A[icol][l]*pivinv;
                        b[icol][l]=b[icol][l]*pivinv;
                }                
                for (ll=0;ll<n;ll++)
                {
                        if (ll!=icol)
                        {
                                dum=A[ll][icol];
                                A[ll][icol]=0;
                                for (l=0;l<n;l++)
                                {
                                        A[ll][l]=A[ll][l]-(A[icol][l]*dum);
                                        b[ll][l]=b[ll][l]-(b[icol][l]*dum);
                                }
                        }
                }        
        }
        for (l=n-1;l>=0;l--)
        {
                if (indxr[l]!=indxc[l])
                {
                        for (k=0;k<n;k++)
                                swap(&A[k][indxr[l]],&A[k][indxc[l]]);
                }
        }

		delete indxc;
		delete indxr;
		delete ipiv;
		for(i=0;i<n;i++) delete b[i]; 
		delete b;
}