#include "Lowest.h"
#include "FMM.h"
#include "cell.h"
#include "SeaPlug.h"
#include "Systm.h"
#include <omp.h>
#include <iostream>
// FMM params
#define OPENING_ANGLE (real)0.6
#define MAX_MPOLE_ORDER 2

Systm* My = new Systm();

int main(short argc,char **argv){
    #ifdef _OPENMP
	cout<<"Compiled with Open MP -- detected "<<omp_get_num_procs()<<" cores."<<endl;
	omp_set_nested(1); omp_set_num_threads(2); // these settings necessary for parallel recursion, will adjust to have same number threads as logical cores
    #endif  //  _OPENMP // %%% chged from //_OPENMP

	unsigned int num_cells;
	fstream InFile;
   cout<<"About to open file m.txt"<<endl;
    InFile.open("m.txt", ios::in); // needs c string
	if (InFile.good()) cout<<"Opened file"<<endl; 
	  else cout<<"Could not open file"<<endl;
	string junk;

	InFile >> num_cells; getline(InFile,junk,'\n');
        cout<<"Number of cells = "<<num_cells<<endl;
		if(num_cells>MaxCellID) {cout<<"Too many cells!"<<endl; MYEXIT(78);}
        real3 *cell_pos, *cell_M, *cell_H;
        cell_pos=new real3[num_cells];
        cell_M=new real3[num_cells];
        cell_H=new real3[num_cells];

/*        real3 cell_pos[num_cells]; wants num_cells to be const
	real3 cell_M[num_cells];
    real3 cell_H[num_cells];
    */
    real3  cellsize = {10,10,10}; // length of rectangular cells' sides, must be cubic for now

   unsigned int i;
	for (i=0; i<num_cells; i++) 
	{   for(short j=0;j<3;j++) {InFile>>cell_pos[i][j]; cell_pos[i][j]*=cellsize[j];}
	    for(short j=0;j<3;j++) InFile>>cell_M[i][j]; 
            getline(InFile,junk,'\n');
            //cout<<"i="<<i<<endl;
        if((i&262143)==0) cout<<"Cell at "<<cell_pos[i][0]<<", "<<cell_pos[i][1]<<", "<<cell_pos[i][2]<<
            " has M="<<cell_M[i][0]<<","<<cell_M[i][1]<<","<<cell_M[i][2]<<endl;
	}

/*
    real3 cell_pos[] = { { 0, 0,  0}, { 0, 8, 0} };
    real3 cell_M[]   = { { 0, 0,500}, { 0, 0, 0} };

    unsigned short num_cells = sizeof(cell_M)/sizeof(real3);

    if (num_cells != (sizeof(cell_pos)/sizeof(real3))) {
        cout<<"Different number of position and initial M vectors! Press any key to exit..."<<endl;
        cin.get();
        exit(1);
    }
*/
    // first call PutOnTree to set up FMM tree and partner's lists, etc.
    cout<<"About to call PutOnTree"<<endl;
    PutOnTree(num_cells, cell_pos, cellsize, OPENING_ANGLE, MAX_MPOLE_ORDER);
    cout<<"Finished PutOnTree"<<endl;
    // Now can calculate H given M. Currently somewhat inefficient, multiple conversions to MVectors and back.
    CalcHfromM(cell_M,cell_H);
    cout<<"Returned from CalcHfromM"<<endl;

    // Display calculated H and exit
    PrintCellsInfo();
#ifdef WIN32
    cout<<"Press any key to exit..."<<endl;
    cin.get();
#endif
    return 0;
}
