#ifndef MPOLE_H
#define MPOLE_H

class MVector;
class Systm;
class int3;
extern Systm *My;

//#include "Lowest.h"
#include <fstream> // for ofstream,ifstream

class mpole
{
  friend std::ostream& operator<<(std::ostream&, const mpole&);
  friend std::istream& operator>>(std::istream&, mpole&);
  friend mpole operator*(const mpole&, const real&);//multiplication by a real number   
    // why is this a friend?
public:
  real *values; // actual numbers Q_n_i as in paper
  short order; // order of the mpole; I considered having that static, but it's
    // convenient to be able to change it for looping order.
    // ALso, someday it might be useful to use higher orders for large cells?
  //member functions:
  mpole(short orderIn=-1);  //constructor, allocate memory for valu
  //mpole(const mpole&);  //copy-constructor
  ~mpole();  //destructor, deallocate memory occupied by values
  real compare (const mpole *);//returns the difference between two mpoles
  real& GetValue(short, short, short); //to get value[short][short][short]
  const real& GetValue(short, short, short) const; //constant version of the previous function
  void SetToZero(); //set values to be zero
  bool IsNonZero();
  //void print0(char *, std::ostream &); //to output values
  void printMP(char *, std::ostream &, unsigned short Num=65535); //sl. different from print0
  void SetToSimplePowers(const MVector &);
  //this[n] = cx^nx*cy^ny*cz^nz
  void SetToPowers(const MVector &); //this[n] = cx^nx*cy^ny*cz^nz/n!
  void InsertVector(const MVector &); 
  //set values 1,2,3 to c[0], c[1], c[2]; other values unchanged (need SetToZero first)
  void SetToDeriv(const MVector &,mpole* scratch2);//set values to D[r] see paper
    //set values_p = Sum_t{W(t)*(-.5*t)^p/p!}  (DMApf)
  void rescale (real factor); //divide values by factor^(n+1)
  void AddTaylor(const mpole *, const MVector &, mpole* scratch1, mpole* scratch2);//add Taylor expansion
  void AddUpConv(const mpole *, const mpole *);//up-convolution
  void AddDownConv(const mpole *, const mpole *, short Extra1);//down-convolution
  void AddMult(const mpole *, const real &); // adds a multiple of another multipole
  void AddShift(const mpole*, const MVector &);//shift the origin of multipole moment
  void AddCarefully(const int3 pVec, const real term1); // add to values[p], set =0 if close
  //overloaded operations
  real operator*(const mpole& right) const;  //dot-product
  real operator*(const MVector& right) const; // ??
  mpole operator/(const real&) const;  //division by a real number
  mpole operator+(const mpole&) const; //mpole addition
  const mpole & operator+= (const mpole&);
  const mpole & operator*= (const real &); // mult. by real
  const mpole & operator= (const mpole&);  //assignment
#ifndef H_ONLY
    void SetToPowerSym (const bool*);
#endif  //  
};

#endif  //   |MPOLE.H

