// file utility.h
#ifndef _UTILITY_H_ 
#define _UTILITY_H_
// higher level than Lowest.h, lower than all else
//project includes
#include "Lowest.h"
// #include "MVector.h" // lower level?
#include <fstream>

#ifndef EXIT1
#define EXIT1(ss) {cout<<"Error: "<<ss<<endl; cin.get(); exit(1);}
#endif  //  
class AnisLayers // really power law plus constant
{	public:
	int NLayers;
	real AnisLayer[25];// max of 25 layers
	real endL[25]; // end position, in nm from left
	real coef; // Diff is high-low
	inline void ReadLines(ifstream &F1,real Ms) 
	{ string junk; NLayers=0; getline(F1,junk); F1>>ws; 
	  while (F1.peek()!=(int)'!')
      { if (NLayers==25) {cout<<"Too many layers:"<<NLayers<<endl; MYEXIT(3);}
        F1>>AnisLayer[NLayers]>>endL[NLayers]; getline(F1,junk); F1>>ws; // skip white space
		//cout<<AnisLayer[NLayers]<<" ends@ "<<endL[NLayers]<<endl;
		AnisLayer[NLayers++]/=Ms;
	  }
	  if (!F1) EXIT1("Read Error, AnisLayers::ReadLine");
	} // end ReadLines

		inline void Write() {cout<<"Layers end at ";
		  for (int i=0; i<NLayers; i++) cout<<endL[i]<<" ";
		  cout<<endl<<"Layer anis =";
		  for (int i=0; i<NLayers; i++) cout<<AnisLayer[i]<<" "; cout<<endl;
		}
	inline real AnisValue(real x) // anis of cell centered at x
	   {for (int i=0; i<NLayers;i++) if(x<endL[i]) return AnisLayer[i]; 
	   cout<<" CellCenter "<<x<<" is not in any layer"<<endl; MYEXIT(92);}
}; // end class

class PowerLaw // really power law plus constant
{	public:
	real exponent;
	real constant;
	real coef; // Diff is high-low
	inline void SetCoef(real Diff, real x) 
		{coef=Diff/pow(x,exponent);}
	// value = constant + coef * x^exponent
	inline real value(real x) {return constant+coef*pow(x,exponent);}
	inline real indefInt(real x) {return constant*x+coef*pow(x,exponent+1)/(exponent+1);}
	// friend ostream& operator<< (ostream&, const PowerLaw&); 
	// perhaps must be in utility.cpp?:
//    inline ostream& operator<< (ostream& fout, const PowerLaw& p) {
//		fout<<"PowerLaw = "<<p.constant<<"+"<<p.coef<<"^"<<p.exponent<<endl;
//		return fout;}
}; // end class

class Cubic // allow 3rd order polynomial 
{	public:
	real C0,C1,C2,C3; // H_K = c0+C1*x+C2x^2+C3x^3
	inline real indefInt(real x) {return x*(C0+x*(0.5*C1+x*(C2/3+x*0.25*C3)));}
}; // end class

#endif  //   //_UTILITY_H_
